SystemOrganization addCategory: #'Pier-Tests-Model-Command'!
SystemOrganization addCategory: #'Pier-Tests-Model-Core'!
SystemOrganization addCategory: #'Pier-Tests-Model-Document'!
SystemOrganization addCategory: #'Pier-Tests-Model-Kernel'!
SystemOrganization addCategory: #'Pier-Tests-Model-Magritte'!
SystemOrganization addCategory: #'Pier-Tests-Model-Mocks'!
SystemOrganization addCategory: #'Pier-Tests-Model-Persistence'!
SystemOrganization addCategory: #'Pier-Tests-Model-Structure'!
SystemOrganization addCategory: #'Pier-Tests-Model-Utilities'!

TestCase subclass: #PRDocumentParserTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRDocumentParserTest methodsFor: 'running' stamp: 'lr 4/5/2007 13:53'!
setUp
	parser := PRDocumentParser new! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 14:04'!
testEscape1
	self assert: (parser class escape: '' using: 'a') = ''.
	self assert: (parser class escape: 'a' using: 'a') = '\a'.
	self assert: (parser class escape: 'ab' using: 'a') = '\ab'.
	self assert: (parser class escape: 'ba' using: 'a') = 'b\a'.
	self assert: (parser class escape: 'bab' using: 'a') = 'b\ab'! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 14:05'!
testEscape2
	self assert: (parser class escape: 'aa' using: 'a') = '\a\a'.
	self assert: (parser class escape: 'aab' using: 'a') = '\a\ab'.
	self assert: (parser class escape: 'baa' using: 'a') = 'b\a\a'.
	self assert: (parser class escape: 'baab' using: 'a') = 'b\a\ab'! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 15:54'!
testEscape3
	self assert: (parser class escape: 'a' using: 'aa') = 'a'.
	self assert: (parser class escape: 'aa' using: 'aa') = '\aa'.
	self assert: (parser class escape: 'aaa' using: 'aa') = '\aaa'.
	self assert: (parser class escape: 'aaaa' using: 'aa') = '\aa\aa'! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'lr 2/2/2010 15:28'!
testFindFirstAtIn1
	self assert: (parser class findFirst: 'ab' at: 1 in: '') = 0.
	self assert: (parser class findFirst: 'ab' at: 1 in: 'ab') = 1.
	self assert: (parser class findFirst: 'ab' at: 1 in: 'cab') = 2.
	self assert: (parser class findFirst: 'ab' at: 1 in: '\ab') = 0.
	self assert: (parser class findFirst: 'ab' at: 1 in: 'c\ab') = 0.
	self assert: (parser class findFirst: 'ab' at: 1 in: '\abab') = 4.
	self assert: (parser class findFirst: 'ab' at: 1 in: 'c\abab') = 5! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'lr 2/2/2010 15:28'!
testFindFirstAtIn2
	self assert: (parser class findFirst: 'ab' at: 2 in: 'ab') = 0.
	self assert: (parser class findFirst: 'ab' at: 2 in: 'cab') = 2.
	self assert: (parser class findFirst: 'ab' at: 5 in: '\abab') = 0.
	self assert: (parser class findFirst: 'ab' at: 5 in: 'c\abab') = 5! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testNextCrLf1
	parser initializeOn: ('a' , (String with: Character cr) , 'b') readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine = 'b'.
	self assert: parser nextLine isNil.
	parser initializeOn: ('a' , (String with: Character lf) , 'b') readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine = 'b'.
	self assert: parser nextLine isNil.
	parser initializeOn: ('a' , (String with: Character cr) , (String with: Character lf) , 'b') readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine = 'b'.
	self assert: parser nextLine isNil! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testNextCrLf2
	parser initializeOn: ((String with: Character lf) , 'a') readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil.
	parser initializeOn: ((String with: Character cr) , 'a') readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil.
	parser initializeOn: ((String with: Character cr) , (String with: Character lf) , 'a') readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testNextCrLf3
	parser initializeOn: ('a' , (String with: Character lf)) readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil.
	parser initializeOn: ('a' , (String with: Character cr)) readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil.
	parser initializeOn: ('a' , (String with: Character cr) , (String with: Character lf)) readStream.
	self assert: parser nextLine = 'a'.
	self assert: parser nextLine isNil! !

!PRDocumentParserTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testNextCrLf4
	parser initializeOn: ((String with: Character lf) , (String with: Character lf)) readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = ''.
	self assert: parser nextLine isNil.
	parser initializeOn: ((String with: Character cr) , (String with: Character cr)) readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = ''.
	self assert: parser nextLine isNil.
	parser initializeOn: ((String with: Character cr) , (String with: Character lf)) readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine isNil.
	parser initializeOn: ((String with: Character lf) , (String with: Character cr)) readStream.
	self assert: parser nextLine = ''.
	self assert: parser nextLine = ''.
	self assert: parser nextLine isNil! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 14:02'!
testUnescape1
	self assert: (parser class unescape: '\a') = 'a'.
	self assert: (parser class unescape: '\ab') = 'ab'.
	self assert: (parser class unescape: 'b\a') = 'ba'.
	self assert: (parser class unescape: 'b\ab') = 'bab'! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 14:02'!
testUnescape2
	self assert: (parser class unescape: '\a\a') = 'aa'.
	self assert: (parser class unescape: '\a\ab') = 'aab'.
	self assert: (parser class unescape: 'b\a\a') = 'baa'.
	self assert: (parser class unescape: 'b\a\ab') = 'baab'! !

!PRDocumentParserTest methodsFor: 'testing-escaping' stamp: 'lr 4/5/2007 14:03'!
testUnescape3
	self assert: (parser class unescape: '') = ''.
	self assert: (parser class unescape: '\') = ''.
	self assert: (parser class unescape: '\\') = '\'.
	self assert: (parser class unescape: '\\\') = '\'.
	self assert: (parser class unescape: '\\\\') = '\\'! !

TestCase subclass: #PRObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Core'!

PRObjectTest subclass: #PRCommandTest
	instanceVariableNames: 'kernel structure context command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

PRCommandTest subclass: #PRAddCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PRAddCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRAddCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRAddCommand! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testAddChild
	| child |
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration
		includes: self command name).

	child := self structure childrenDecoration
		at: self command name.
	self assert: child name = self command name.
	self assert: child species = self command type! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 1/10/2007 10:49'!
testAddConflict
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError! !

!PRAddCommandTest methodsFor: 'testing-accessing' stamp: 'lr 4/15/2009 18:23'!
testLink
	| link |
	self assert: self command link isNil.
	
	link := PRInternalLink new.
	link owner: self command structure.
	self command link: link.
	self assert: self command link = link.
	self assert: link isBroken.
	
	self command execute.
	self deny: link isBroken.
	self assert: link target name = self command name.
	self assert: link reference = 'untitled'! !

!PRAddCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:43'!
testName
	self assert: self command name = 'untitled'.
	self command name: 'something'.
	self assert: self command name = 'something'! !

!PRAddCommandTest methodsFor: 'testing-utilties' stamp: 'lr 11/3/2009 22:03'!
testSuggestName
	command := self command
		suggestName: 'sucker for your sound'.
	self assert: self command name = 'sucker-for-your-sound'.
	self assert: self command title = 'Sucker for your sound'.
	
	command := self command
		suggestName: 'Gameboy/Homeboy'.
	self assert: self command name = 'Gameboy_Homeboy'.
	self assert: self command title = 'Gameboy/Homeboy'! !

!PRAddCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:42'!
testType
	self assert: self command type = PRPage.
	self command type: PRFile.
	self assert: self command type = PRFile! !

!PRAddCommandTest methodsFor: 'testing-utilties' stamp: 'lr 3/30/2009 21:59'!
testTypeClasses
	| classes |
	PRCurrentContext
		use: self
		during: [ classes := self actualClass structureClasses ].
	self assert: (classes notEmpty).
	self assert: (classes includes: PRPage)! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:25'!
testUncheckedConflict
	self command execute.	
	self command beUnchecked.
	self command structure enumerator
		do: [ :each | each remove ].	
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError! !

!PRAddCommandTest methodsFor: 'testing-utilties' stamp: 'lr 4/21/2009 15:25'!
testUniqueTitle
	20 timesRepeat: [
		self
			shouldnt: [
				self structure addChild: (PRPage named: (self command
					uniqueName: 'foo' in: self structure)) ]
			raise: PRConflictingNameError ].
	#( 'foo' 'foo-2' 'foo-9' 'foo-10' 'foo-11' 'foo-20' ) do: [ :each |
		self assert: (self structure childrenDecoration includes: each) ]! !

!PRCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRCommand! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 2/24/2007 21:04'!
actualInstance
	^ self actualClass new! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
command
	^ command ifNil: [ command := self actualInstance ]! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
context
	^ context ifNil: [ context := self contextInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 2/24/2007 21:03'!
contextInstance
	^ PRContext kernel: self kernel structure: self structure command: self command! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self command! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
kernelInstance
	^ PRKernel new
		root: ((PRPage named: 'root')
			addChild: (PRPage named: 'folder');
			addChild: (self structure);
			yourself);
		yourself! !

!PRCommandTest methodsFor: 'running' stamp: 'lr 2/24/2007 21:08'!
setUp
	context := self contextInstance! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
structure
	^ structure ifNil: [ structure := self structureInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 1/15/2007 21:34'!
structureInstance
	^ PRPage named: 'command'! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:39'!
testAccessKey
	self assert: (self actualClass accessKey isNil or: [ self actualClass accessKey isCharacter ])! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 10/22/2007 22:17'!
testAnswer
	self assert: self command answer isNil.
	self command answer: self context.
	self deny: self command answer = self context! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 10/22/2007 22:06'!
testContext
	self assert: self command context notNil.
	context := self context command: self command.
	self assert: self command context = self context! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'jf 9/30/2009 00:19'!
testDate
	| stamp |
	self assert: self command date isNil.
	self command timestamp: (stamp := GRPlatform current magritteTimeStampClass now).
	self assert: self command date = stamp date! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 2/12/2007 19:07'!
testIsChecked
	self assert: self command isChecked.

	self command beUnchecked.
	self deny: self command isChecked.

	self command beChecked.
	self assert: self command isChecked! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/30/2009 21:52'!
testIsEdit
	self deny: self command isEdit! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self assert: self command isLogged! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsQuick
	self deny: self command isQuick! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsView
	self deny: self command isView! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testKernel
	self assert: self command kernel = self kernel! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:50'!
testLabel
	self assert: self actualClass label isString.
	self assert: self actualClass label isEmpty not.
	
	self assert: self instance label isString.
	self assert: self instance label isEmpty not! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	self assert: self command root = self kernel root! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:40'!
testShortLabel
	self assert: self actualClass shortLabel isString.
	self assert: self actualClass shortLabel isEmpty not! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testStructure
	self assert: self command structure = self structure! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'jf 9/30/2009 00:19'!
testTime
	| stamp |
	self assert: self command time isNil.
	self command timestamp: (stamp := GRPlatform current magritteTimeStampClass now).
	self assert: self command time = stamp time! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'jf 9/30/2009 00:19'!
testTimestamp
	| stamp |
	self assert: self command timestamp isNil.
	self command timestamp: (stamp := GRPlatform current magritteTimeStampClass now).
	self assert: self command timestamp = stamp! !

!PRCommandTest methodsFor: 'testing-utilities' stamp: 'lr 2/12/2007 19:07'!
testUniqueName
	20 timesRepeat: [
		self
			shouldnt: [
				self structure addChild: (PRPage named: (self command
					uniqueName: 'foo' in: self structure)) ]
			raise: PRConflictingNameError ]! !

!PRCommandTest methodsFor: 'testing-utilities' stamp: 'lr 2/12/2007 19:07'!
testUniqueNameDoesNotAddDecoration
	self command uniqueName: 'foo' in: self structure.
	self structure
		decorationOfClass: self structure childrenDecorationClass
		ifAbsent: [ ^ self ].
	self assert: self structure hasChildren! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 1/10/2007 10:49'!
testValidateChild
	self
		should: [
			self command
				validateChild: (PRPage named: 'folder')
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: (PRPage named: 'zork')
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 1/15/2007 21:34'!
testValidateChildDoesNotAddDecoration
	self command
		validateChild: (PRPage named: 'zork')
		in: self context root.
	self structure
		decorationOfClass: self structure childrenDecoration
		ifAbsent: [ ^ self ].
	self assert: self structure hasChildren! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 1/15/2007 21:34'!
testValidateChildNamed
	self
		should: [
			self command
				validateChild: PRPage new
				named: 'folder'
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: PRPage new
				named: 'zork'
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: (self context root childrenDecoration
					at: 'folder')
				named: 'zork'
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 1/10/2007 10:49'!
testValidateName
	self
		shouldnt: [
			self command
				validateName: 'zork'
				of: PRPage new
				in: self context root ]
		raise: PRConflictingNameError.
	self
		should: [
			self command
				validateName: 'folder'
				of: PRPage new
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateName: 'zork'
				of: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateName: 'folder'
				of: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 1/15/2007 21:34'!
testValidateNesting
	self
		shouldnt: [
			self command
				validateNestingOf: self context root
				in: PRPage new ]
		raise: PRInvalidNestingError.
	self
		shouldnt: [
			self command
				validateNestingOf: PRPage new
				in: self context root ]
		raise: PRInvalidNestingError! !

PRCommandTest subclass: #PREditCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PREditCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PREditCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PREditCommand! !

!PREditCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/30/2009 21:52'!
testIsEdit
	self assert: self command isEdit! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleChanged
	| title |
	self command
		write: (title := 'foo')
		using: PRStructure descriptionTitle.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure title = title! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleInitialized
	self assert: (self command readUsing: PRStructure descriptionTitle) = self structure title! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleUnchanged
	| title |
	title := self structure title.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure title = title! !

PREditCommandTest subclass: #PREditFileCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PREditFileCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PREditFileCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRFile named: 'command'! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileChanged
	| file |
	self command
		write: (file := MAFileModel new
			contents: 'foobar';
			filename: 'test.txt';
			mimetype: 'text/plain';
			yourself)
		using: PRFile descriptionFile.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileInitialized
	self assert: (self command readUsing: PRFile descriptionFile) = self structure file! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileUnchanged
	| file |
	file := self structure file.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file! !

PREditCommandTest subclass: #PREditPageCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PREditPageCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PREditPageCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRPage named: 'command'! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 10/18/2007 17:38'!
testContentsChanged
	| document |
	document := PRPage descriptionDocument
		fromString: '!!foo'.
	self command
		write: document
		using: PRPage descriptionDocument.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure document = document! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 10/18/2007 17:37'!
testContentsInitialized
	self assert: (self command readUsing: PRPage descriptionDocument) = self structure document! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 10/18/2007 17:38'!
testContentsUnchanged
	| document |
	document := self structure document.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure document = document! !

PRCommandTest subclass: #PRLocationCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

PRLocationCommandTest subclass: #PRCopyCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PRCopyCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRCopyCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRCopyCommand! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopy
	self command name: 'foo'.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure parent childrenDecoration
		includes: 'foo').
	self assert: (self structure parent childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopyIntoChild
	self command
		name: 'foo';
		target: self structure.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration
		includes: 'foo').
	self assert: (self structure childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopyIntoRoot
	self command
		name: 'foo';
		target: self command root.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self command root childrenDecoration
		includes: 'foo').
	self assert: (self command root childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 4/10/2006 14:52'!
testCopyTitle
	self command name: 'foo'; execute.
	self assert: (self structure title) = 'Command'.
	self assert: (self structure parent childrenDecoration
		at: 'foo') title = 'Foo'! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	super testInitialized.
	self assert: self structure name , ' copy' = self command name! !

!PRLocationCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRLocationCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRLocationCommand! !

!PRLocationCommandTest methodsFor: 'testing' stamp: 'lr 1/10/2007 10:50'!
testConflict
	self command name: 'folder'.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError! !

!PRLocationCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	self assert: self command target = self structure parent! !

PRLocationCommandTest subclass: #PRMoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PRMoveCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRMoveCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRMoveCommand! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	super testInitialized.
	self assert: self structure name = self command name! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMove
	self command target: self command root.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self command root childrenDecoration
		includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMoveIntoChild
	self command target: self structure.
	self
		should: [ self command execute ]
		raise: PRInvalidNestingError.
	self assert: (self structure parent childrenDecoration
		includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMoveIntoFolder
	self command target: (self command root childrenDecoration
		at: 'folder').
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self deny: (self command root childrenDecoration
		includes: self structure name).
	self assert: ((self command root childrenDecoration
		at: 'folder') childrenDecoration
			includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRename
	self command name: 'foo'.
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError.
	self deny: (self structure parent childrenDecoration
		includes: 'command').
	self assert: (self structure parent childrenDecoration
		includes: 'foo')! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRenameExisting
	self command name: 'folder'.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError.
	self assert: (self structure parent childrenDecoration
		includes: 'command').
	self assert: (self structure parent childrenDecoration
		includes: 'folder')! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 6/12/2009 11:00'!
testRenameOrder
	self kernel root
		addChild: (PRPage named: 'other').
	self assert: (self kernel root enumerator
		collect: [ :each | each name ])
			= #('folder' 'command' 'other').

	self command name: 'renamed'.
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError.
	self assert: (self kernel root enumerator
		collect: [ :each | each name ])
			= #('folder' 'renamed' 'other')! !

PRCommandTest subclass: #PROrderCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PROrderCommandTest class methodsFor: 'testing' stamp: 'lr 3/18/2008 23:14'!
isAbstract
	^ false! !

!PROrderCommandTest methodsFor: 'private' stamp: 'lr 3/18/2008 23:12'!
actualClass
	^ PROrderCommand! !

!PROrderCommandTest methodsFor: 'accessing' stamp: 'lr 3/18/2008 23:25'!
children
	^ self context enumerator contents! !

!PROrderCommandTest methodsFor: 'accessing' stamp: 'lr 3/18/2008 23:31'!
childrenNames
	^ self children collect: [ :each | each name ]! !

!PROrderCommandTest methodsFor: 'private' stamp: 'lr 3/18/2008 23:21'!
structureInstance
	^ super structureInstance
		addChild: (PRPage named: 'a');
		addChild: (PRPage named: 'b');
		addChild: (PRPage named: 'c');
		yourself! !

!PROrderCommandTest methodsFor: 'testing-setup' stamp: 'lr 11/15/2009 23:38'!
testDefaultOrder
	self assert: self childrenNames = #( 'a' 'b' 'c' ).
	self assert: (self command class isValidIn: self context)! !

!PROrderCommandTest methodsFor: 'testing' stamp: 'lr 3/18/2008 23:28'!
testInitialized
	self children
		with: self command structures
		do: [ :a :b | self assert: a = b ]! !

!PROrderCommandTest methodsFor: 'testing' stamp: 'lr 8/29/2008 12:01'!
testReorderBasic
	self command structures
		swap: 1 with: 3.
	self
		shouldnt: [ self command execute ]
		raise: Error.
	self assert: self childrenNames = #( 'c' 'b' 'a' )! !

!PROrderCommandTest methodsFor: 'testing' stamp: 'lr 8/29/2008 12:01'!
testReorderWithConcurrentAdd
	self command structures
		swap: 1 with: 3.
	self structure childrenDecoration
		add: (PRPage named: 'd').
	self
		shouldnt: [ self command execute ]
		raise: Error.
	self assert: self childrenNames = #( 'c' 'b' 'a' 'd' )! !

!PROrderCommandTest methodsFor: 'testing' stamp: 'lr 8/29/2008 12:01'!
testReorderWithConcurrentDelete
	self command structures
		swap: 1 with: 3.
	self structure childrenDecoration
		remove: self children first.
	self
		shouldnt: [ self command execute ]
		raise: Error.
	self assert: self childrenNames = #( 'c' 'b' )! !

PRCommandTest subclass: #PRRemoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PRRemoveCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRRemoveCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRRemoveCommand! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRemoveLeaf
	self assert: (self kernel root childrenDecoration
		includes: self structure name).
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure parent isNil.
	self deny: (self kernel root childrenDecoration
		includes: self structure name)! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRemoveNode
	self structure
		addChild: (PRPage named: 'foo');
		addChild: (PRPage named: 'bar').
	self assert: (self kernel root childrenDecoration
		includes: self structure name).
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure parent isNil.
	self deny: (self kernel root childrenDecoration
		includes: self structure name)! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/5/2007 14:06'!
testRemoveRoot
	context := self context
		structure: self kernel root
		command: self actualClass new.
	self
		should: [ context command execute ]
		raise: PRStructureError! !

PRCommandTest subclass: #PRViewCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Command'!

!PRViewCommandTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRViewCommandTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRViewCommand! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self deny: self command isLogged! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsView
	self assert: self command isView! !

!PRViewCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testSimple
	self
		should: [ self command execute ]
		raise: Error! !

PRObjectTest subclass: #PRContextTest
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Kernel'!

!PRContextTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRContextTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRContext! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
context
	^ context ifNil: [ context := self contextInstance ]! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self context! !

!PRContextTest methodsFor: 'testing-conveniance' stamp: 'lr 5/10/2008 13:23'!
testCommands
	self assert: (self context commands notEmpty).
	self assert: (self context commands includes: PRViewCommand).
	self assert: (self context commands includes: PRRemoveCommand) not.
	
	context := self context structure: (self context structure childrenDecoration at: 'folder').
	self assert: (self context commands notEmpty).
	self assert: (self context commands includes: PRViewCommand).
	self assert: (self context commands includes: PRRemoveCommand)
! !

!PRContextTest methodsFor: 'testing' stamp: 'lr 8/14/2007 23:51'!
testCopy
	| copy |
	copy := self context copy.
	self assert: self context command context == self context.
	self assert: copy command context == copy! !

!PRContextTest methodsFor: 'testing' stamp: 'lr 4/13/2007 14:57'!
testEnumerator
	| array |
	array := self context enumerator contents.
	self assert: array first name = 'folder'.
	self assert: array size = 1! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 4/13/2007 14:59'!
testGotoCommand
	| current currentStructure currentCommand next nextCommand |
	currentStructure := self context structure.
	currentCommand := self context command.
	current := self context.

	nextCommand := self context structure editCommandClass new.
	next := self context command: nextCommand.
	self deny: current = next.

	self assert: current structure = currentStructure.
	self assert: current command = currentCommand.

	self assert: next structure = currentStructure.
	self assert: next command = nextCommand! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 4/13/2007 14:59'!
testGotoStructure
	| current currentStructure currentCommand next nextStructure |
	currentStructure := self context structure.
	currentCommand := self context command.
	current := self context.

	nextStructure := self context structure childrenDecoration at: 'folder'.
	next := self context structure: nextStructure.
	self deny: current = next.

	self assert: current structure = currentStructure.
	self assert: current command = currentCommand.

	self assert: next structure = nextStructure.
	self assert: next command isView! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 4/13/2007 15:00'!
testGotoStructureCommand
	| current currentStructure currentCommand next nextStructure nextCommand |
	currentStructure := self context structure.
	currentCommand := self context command.
	current := self context.

	nextStructure := self context structure childrenDecoration at: 'folder'.
	nextCommand := nextStructure editCommandClass new.
	next := self context structure: nextStructure command: nextCommand.
	self deny: current = next.

	self assert: current structure = currentStructure.
	self assert: current command = currentCommand.

	self assert: next structure = nextStructure.
	self assert: next command = nextCommand! !

!PRContextTest methodsFor: 'testing' stamp: 'lr 4/13/2007 14:52'!
testInitialState
	self assert: self context structure = self context root.
	self assert: self context command isView! !

!PRContextTest methodsFor: 'testing-conveniance' stamp: 'lr 5/10/2008 13:12'!
testParent
	self assert: self context parent isNil.
	
	context := self context structure: (self context structure childrenDecoration at: 'folder').
	self assert: self context root == self context parent.

	context := self context structure: (self context structure childrenDecoration at: 'child').
	self assert: (self context root childrenDecoration at: 'folder') == context parent! !

!PRContextTest methodsFor: 'testing-conveniance' stamp: 'lr 5/10/2008 13:12'!
testRoot
	self assert: self context root == self context structure.
	
	context := self context structure: (self context structure childrenDecoration at: 'folder').
	self assert: self context root == self context parent.

	context := self context structure: (self context structure childrenDecoration at: 'child').
	self assert: self context root == self context parent parent! !

!PRContextTest methodsFor: 'testing-conveniance' stamp: 'lr 5/10/2008 13:15'!
testSiblings
	self assert: self context siblings = (Array with: self context root).
	
	context := self context structure: (self context structure childrenDecoration at: 'folder').
	self assert: self context siblings = (Array with: self context structure).

	context := self context structure: (self context structure childrenDecoration at: 'child').
	self assert: (self context siblings includes: self context structure).
	self assert: self context siblings size = 2! !

PRObjectTest subclass: #PRDecoratedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

!PRDecoratedTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRDecoratedTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRDecorated! !

!PRDecoratedTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decorationWithPriority: anInteger
	^ PRMockDecoration new
		priority: anInteger;
		yourself! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 3/5/2007 14:00'!
testAddDecoration
	| mock1 mock2 index1 index2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance addDecoration: mock1) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: (self instance decorations includes: mock1).

	self assert: (self instance addDecoration: mock2) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: (self instance decorations includes: mock2).

	index1 := self instance decorations indexOf: mock1.
	index2 := self instance decorations indexOf: mock2.
	self assert: index1 > index2.

	self should: [ self instance addDecoration: mock1 ] raise: PRDecorationError.
	self should: [ self instance addDecoration: mock2 ] raise: PRDecorationError.
	self assert: (self instance decorations includes: mock2).
	self assert: (self instance decorations includes: mock2)! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAddDecorationIfPresent
	| mock1 mock2 index1 index2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance
		addDecoration: mock1
		ifPresent: [ :value | self assert: false ]) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: (self instance decorations includes: mock1).

	self assert: (self instance
		addDecoration: mock2
		ifPresent: [ :value | self assert: false ]) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: (self instance decorations includes: mock2).

	index1 := self instance decorations indexOf: mock1.
	index2 := self instance decorations indexOf: mock2.
	self assert: index1 > index2.

	self assert: (self instance
		addDecoration: mock1
		ifPresent: [ :value | nil ]) isNil.
	self assert: (self instance
		addDecoration: mock2
		ifPresent: [ :value | nil ]) isNil.
	self assert: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2)! !

!PRDecoratedTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecorations
	| decoration copiedInstance copiedDecoration |
	decoration := self instance addDecoration: (self decorationWithPriority: SmallInteger minVal).
	copiedInstance := self instance copy.
	copiedDecoration := copiedInstance decorations first.

	self deny: self instance == copiedInstance.
	self deny: decoration == copiedDecoration.

	self assert: self instance decorations first = decoration.
	self assert: self instance = decoration decorated.

	self assert: copiedInstance decorations first = copiedDecoration.
	self assert: copiedInstance = copiedDecoration decorated! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 3/5/2007 14:00'!
testDecorationOfClass
	| mock |
	self should: [ self instance decorationOfClass: PRMockDecoration ] raise: PRDecorationError.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 3/9/2006 11:31'!
testDecorationOfClassIfAbsent
	| mock |
	self assert: (self instance decorationOfClass: PRMockDecoration ifAbsent: [ nil ]) isNil.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 3/9/2006 11:31'!
testDecorationsDo
	| first second |
	self instance
		addDecoration: (first := self decorationWithPriority: SmallInteger minVal);
		addDecoration: (second := self decorationWithPriority: SmallInteger maxVal).
	self instance decorationsDo: [ :each |
		(first notNil and: [ second notNil and: [ each = first ] ])
			ifTrue: [ first := nil ].
		(first isNil and: [ second notNil and: [ each = second ] ])
			ifTrue: [ second := nil ] ].
	self assert: first isNil.
	self assert: second isNil! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 3/9/2006 11:31'!
testDecorationsDoOwnerDo
	| instance first second |
	instance := self instance
		addDecoration: (first := self decorationWithPriority: SmallInteger minVal);
		addDecoration: (second := self decorationWithPriority: SmallInteger maxVal);
		yourself.
	self instance
		decorationsDo: [ :each |
			(first notNil and: [ instance notNil and: [ second notNil and: [ each = first ] ] ])
				ifTrue: [ first := nil ].
			(first isNil and: [ instance isNil and: [ second notNil and: [ each = second ] ] ])
				ifTrue: [ second := nil ] ]
		ownerDo: [ :each |
			self assert: first isNil.
			self assert: second notNil.
			self assert: instance notNil.
			instance := nil ].
	self assert: first isNil.
	self assert: second isNil.
	self assert: instance isNil! !

!PRDecoratedTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	self assert: (self instance decorations isKindOf: Collection)! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 3/5/2007 14:00'!
testRemoveDecoration
	| mock1 mock2 |
	self instance
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: (self instance removeDecoration: mock1) = mock1.
	self deny: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2) = mock2.
	self deny: (self instance decorations includes: mock1).
	self deny: (self instance decorations includes: mock2).

	self should: [ self instance removeDecoration: mock2 ] raise: PRDecorationError! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 3/9/2006 11:31'!
testRemoveDecorationIfAbsent
| mock1 mock2 |
	self instance
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: (self instance removeDecoration: mock1 ifAbsent: [ nil ]) = mock1.
	self deny: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) = mock2.
	self deny: (self instance decorations includes: mock1).
	self deny: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) isNil! !

PRDecoratedTest subclass: #PRStructureTest
	instanceVariableNames: 'root folder child structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

PRStructureTest subclass: #PRCaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

!PRCaseTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRCaseTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRCase! !

!PRCaseTest methodsFor: 'private' stamp: 'lr 10/18/2007 17:45'!
actualInstance
	^ super actualInstance
		contents: '!!A Title
-A simple List-Element';
		yourself
! !

!PRCaseTest methodsFor: 'testing' stamp: 'lr 10/18/2007 17:45'!
testContents
	self structure contents: nil.
	self assert: self structure contents = ''.

	self structure contents: ''.
	self assert: self structure contents = ''.

	self structure contents: 'Foo'.
	self assert: self structure contents = 'Foo'! !

!PRCaseTest methodsFor: 'testing' stamp: 'lr 4/13/2007 15:27'!
testDocument
	self structure document: PRDocument new.
	self assert: self structure document = PRDocument new.
	self assert: self structure contents = ''.
	
	structure := self actualClass new.
	self assert: structure document = structure defaultDocument! !

!PRCaseTest methodsFor: 'testing-visiting' stamp: 'lr 2/12/2007 19:07'!
testFullTextSearch
	| matches |
	matches := self root fullTextSearch
		subString: 'title';
		caseSensitive: true;
		contents.
	self assert: matches size = 0.

	matches := self root fullTextSearch
		subString: 'Title';
		caseSensitive: true;
		contents.
	self assert: matches size = 1.
	self assert: matches first = self structure.

	matches := self root fullTextSearch
		subString: 'title';
		caseSensitive: false;
		contents.
	self assert: matches size = 1.
	self assert: matches first = self structure.

	matches := self root fullTextSearch
		subString: 'list-element';
		caseSensitive: true;
		contents.
	self assert: matches size = 0.

	matches := self root fullTextSearch
		subString: 'List-Element';
		caseSensitive: true;
		contents.
	self assert: matches size = 1.
	self assert: matches first = self structure.

	matches := self root fullTextSearch
		subString: 'list-element';
		caseSensitive: false;
		contents.
	self assert: matches size = 1.
	self assert: matches first = self structure! !

!PRCaseTest methodsFor: 'testing-testing' stamp: 'lr 3/30/2009 21:38'!
testHasDocument
	self assert: self instance hasDocument! !

!PRCaseTest methodsFor: 'testing-visiting' stamp: 'lr 2/12/2007 19:07'!
testIncomingReferences
	| matches |
	matches := self root incomingReferences
		to: self structure;
		collect: [ :each | each owner ].
	self assert: matches size = 0.

	self root contents: '*/folder/structure*'.
	matches := self root incomingReferences
		to: self structure;
		collect: [ :each | each owner ].
	self assert: matches size = 1.
	self assert: matches first = self root.

	self folder contents: '+/folder/structure+'.
	matches := self root incomingReferences
		to: self structure;
		collect: [ :each | each owner ].
	self assert: matches size = 2.
	self assert: matches first = self root.
	self assert: matches second = self folder! !

!PRCaseTest methodsFor: 'testing-visiting' stamp: 'lr 2/12/2007 19:07'!
testOutgoingReferences
	| matches |
	self structure contents: ''.
	matches := self structure outgoingReferences
		collect: [ :each | each target ].
	self assert: matches size = 0.

	self structure contents: '*/*'.
	matches := self structure outgoingReferences
		collect: [ :each | each target ].
	self assert: matches size = 1.
	self assert: matches first = self root.

	self structure contents: '*.*'.
	matches := self structure outgoingReferences
		collect: [ :each | each target ].
	self assert: matches size = 1.
	self assert: matches first = self structure.

	self structure contents: '*.* */* */*'.
	matches := self structure outgoingReferences
		collect: [ :each | each target ].
	self assert: matches size = 3.
	self assert: matches first = self structure.
	self assert: matches second = self root.
	self assert: matches third = self root! !

!PRCaseTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:49'!
testPlainText
	self structure contents: nil.
	self assert: self structure plainText = ''.

	self structure contents: ''.
	self assert: self structure plainText = ''.

	self structure contents: 'Foo'.
	self assert: self structure plainText = 'Foo'! !

PRCaseTest subclass: #PRPageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

!PRPageTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRPageTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRPage! !

PRStructureTest subclass: #PRFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

!PRFileTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRFileTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRFile! !

!PRFileTest methodsFor: 'testing' stamp: 'lr 12/30/2007 16:34'!
testFile
	| model |
	model := MAMemoryFileModel new.
	self structure file: model.
	self assert: self structure file = model! !

!PRFileTest methodsFor: 'testing-testing' stamp: 'lr 3/30/2009 21:37'!
testIsFile
	self assert: self instance isFile! !

!PRStructureTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRStructure! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass named: 'structure'! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
child
	^ child! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
childInstance
	^ PRPage named: 'child'! !

!PRStructureTest methodsFor: 'utilities' stamp: 'jf 9/30/2009 01:10'!
enumerator: aVisitor gives: aCollection 
	| children |
	children := aVisitor collect: [ :each | each name ].
	self 
		assert: children = aCollection
		description: children greaseString , ' should be ' , aCollection greaseString
		resumable: true! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
folder
	^ folder! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
folderInstance
	^ PRPage named: 'folder'! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ structure! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
root
	^ root! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
rootInstance
	^ PRPage named: 'root'! !

!PRStructureTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	root := self rootInstance.
	folder := self folderInstance.
	child := self childInstance.
	structure := self actualInstance.

	self root addChild: self folder.
	self folder addChild: self child.
	self folder addChild: self structure! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
structure
	^ structure! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testCanBeChildOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self
			shouldnt: [ self structure canBeChildOf: each new ]
			raise: Error ]! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testCanBeParentOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self
			shouldnt: [ self structure canBeParentOf: each new ]
			raise: Error ]! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 4/13/2007 15:15'!
testCommands
	self assert: (self structure viewCommandClass includesBehavior: PRCommand).
	self assert: (self structure editCommandClass includesBehavior: PRCommand)! !

!PRStructureTest methodsFor: 'testing-copying' stamp: 'lr 3/21/2006 18:43'!
testCopyChildren
	| folderCopy childCopy structureCopy |
	folderCopy := self folder copy.
	childCopy := folderCopy childrenDecoration at: 'child'.
	structureCopy := folderCopy childrenDecoration at: 'structure'.

	self deny: self folder = folderCopy.
	self deny: self child = childCopy.
	self deny: self structure = structureCopy.

	self assert: self folder parent = self root.
	self assert: self child parent = self folder.
	self assert: self structure parent = self folder.

	self assert: folderCopy parent isNil.
	self assert: childCopy parent = folderCopy.
	self assert: structureCopy parent = folderCopy! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 9/27/2007 10:05'!
testEnumerator
	self enumerator: self root enumerator gives: #( 'folder' ).
	self enumerator: self root enumerator with gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all gives: #( 'root' 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator everything gives: #( 'root' 'folder' 'child' 'structure' )! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 3/30/2009 22:01'!
testEnumeratorAnySatisfy
	self assert: (self root enumerator everything
		anySatisfy: [ :each | each = self structure ])! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 3/30/2009 22:05'!
testEnumeratorDoSeparatedBy
	| result |
	result := String new.
	self root enumerator everything
		do: [ :each | result := result , each name ]
		separatedBy: [ result := result , ', ' ].
	self assert: result = 'root, folder, child, structure'! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 3/30/2009 22:03'!
testEnumeratorInjectInto
	self assert: (self root enumerator everything
		inject: String new
		into: [ :result :each | result , each name ])
			= 'rootfolderchildstructure'! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 4/1/2009 22:28'!
testEnumeratorReject
	self
		enumerator: (self root enumerator everything
			reject: [ :each | each = self structure ])
		gives: #( 'root' 'folder' 'child' )! !

!PRStructureTest methodsFor: 'testing-enumerator' stamp: 'lr 3/30/2009 22:12'!
testEnumeratorSelect
	self
		enumerator: (self root enumerator everything
			select: [ :each | each = self structure ])
		gives: #( 'structure' )! !

!PRStructureTest methodsFor: 'testing-querying' stamp: 'lr 5/2/2009 10:02'!
testFindAncestor
	self assert: (self structure findAncestor: [ :each | each = self structure ]) = self structure.
	self assert: (self structure findAncestor: [ :each | each = self folder ]) = self folder.
	self assert: (self structure findAncestor: [ :each | each = self root ]) = self root.
	self assert: (self structure findAncestor: [ :each | each = self child ]) isNil! !

!PRStructureTest methodsFor: 'testing-querying' stamp: 'lr 5/2/2009 10:02'!
testFindAncestorIfAbsent
	self assert: (self structure findAncestor: [ :each | each = self structure ] ifAbsent: [ 123 ]) = self structure.
	self assert: (self structure findAncestor: [ :each | each = self folder ]  ifAbsent: [ 123 ]) = self folder.
	self assert: (self structure findAncestor: [ :each | each = self root ] ifAbsent: [ 123 ]) = self root.
	self assert: (self structure findAncestor: [ :each | each = self child ] ifAbsent: [ 123 ]) = 123! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasChildren
	self assert: self root hasChildren.
	self assert: self folder hasChildren.
	self deny: self child hasChildren.
	self deny: self structure hasChildren! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 4/13/2007 15:18'!
testHasDocument
	self assert: self root hasDocument.
	self assert: self folder hasDocument.
	self assert: self child hasDocument! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasParent
	self deny: self root hasParent.
	self assert: self folder hasParent.
	self assert: self child hasParent.
	self assert: self structure hasParent! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 18:09'!
testIncompleteLookupName
	| lookup |
	lookup := self root lookupIncompletePath: '/folder/zork'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'.
	
	lookup := self root lookupIncompletePath: '/folder/zork/'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'.

	lookup := self structure lookupIncompletePath: '../structure/foo/bar'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'foo'.
	
	lookup := self structure lookupIncompletePath: '../structure/foo/bar/'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'foo'! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 18:10'!
testIncompleteLookupTitle
	| lookup |
	lookup := self root lookupIncompletePath: '/Folder/zork'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'.
	
	lookup := self root lookupIncompletePath: '/Folder/zork/'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'.

	lookup := self structure lookupIncompletePath: '../Structure/foo/bar'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'foo'.
	
	lookup := self structure lookupIncompletePath: '../Structure/foo/bar/'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'foo'! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsAncestorOf
	self assert: (self root isAncestorOf: self root).
	self assert: (self root isAncestorOf: self folder).
	self assert: (self root isAncestorOf: self child).
	self assert: (self root isAncestorOf: self structure).

	self deny: (self folder isAncestorOf: self root).
	self assert: (self folder isAncestorOf: self folder).
	self assert: (self folder isAncestorOf: self child).
	self assert: (self folder isAncestorOf: self structure).

	self deny: (self child isAncestorOf: self root).
	self deny: (self child isAncestorOf: self folder).
	self assert: (self child isAncestorOf: self child).
	self deny: (self child isAncestorOf: self structure).

	self deny: (self structure isAncestorOf: self root).
	self deny: (self structure isAncestorOf: self folder).
	self deny: (self structure isAncestorOf: self child).
	self assert: (self structure isAncestorOf: self structure)! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/30/2009 21:36'!
testIsFile
	self deny: self instance isFile! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsRoot
	self assert: self root isRoot.
	self deny: self folder isRoot.
	self deny: self child isRoot.
	self deny: self structure isRoot! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:37'!
testKernel
	self
		should: [ self instance kernel ]
		raise: Error! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testLevel
	self assert: self root level = 1.
	self assert: self folder level = 2.
	self assert: self child level = 3.
	self assert: self structure level = 3! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/21/2009 19:04'!
testLookupCaseSensitive
	| struc |
	struc := self actualInstance 
		name: 'Child';
		title: 'Structure';
		yourself.
	self folder addChild: struc.

	self assert: (self folder lookupPath: 'Child') = struc.
	self assert: (self folder lookupPath: 'CHILD') = self child.
	self assert: (self folder lookupPath: 'Structure') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:07'!
testLookupComposed
	self assert: (self child lookupPath: '../child/..') = self folder.
	self assert: (self child lookupPath: '../child/../') = self folder.

	self assert: (self child lookupPath: '../structure/..') = self folder.
	self assert: (self child lookupPath: '../structure/../') = self folder.

	self assert: (self child lookupPath: '../structure/../child') = self child.
	self assert: (self child lookupPath: '../structure/../child/') = self child.

	self assert: (self child lookupPath: '../structure/../structure') = self structure.
	self assert: (self child lookupPath: '../structure/../structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:11'!
testLookupComposedTitle
	self assert: (self child lookupPath: '../Child/..') = self folder.
	self assert: (self child lookupPath: '../Child/../') = self folder.

	self assert: (self child lookupPath: '../Structure/..') = self folder.
	self assert: (self child lookupPath: '../Structure/../') = self folder.

	self assert: (self child lookupPath: '../Structure/../child') = self child.
	self assert: (self child lookupPath: '../structure/../Child/') = self child.

	self assert: (self child lookupPath: '../Structure/../structure') = self structure.
	self assert: (self child lookupPath: '../structure/../Structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:10'!
testLookupEmpty
	self assert: (self root lookupPath: '') = self root.
	self assert: (self folder lookupPath: '') = self folder.
	self assert: (self child lookupPath: '') = self child.
	self assert: (self structure lookupPath: '') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/21/2009 18:46'!
testLookupError
	self assert: (self root lookupPath: 'unknown') isNil.
	self assert: (self root lookupPath: 'unknown/') isNil.

	self assert: (self root lookupPath: 'zork') isNil.
	self assert: (self root lookupPath: 'zork/') isNil.

	self assert: (self root lookupPath: 'folder/unknown') isNil.
	self assert: (self root lookupPath: 'folder/unknown/') isNil.

	self assert: (self root lookupPath: 'folder/unknown/unknown') isNil.
	self assert: (self root lookupPath: 'folder/unknown/unknown/') isNil.

	self assert: (self root lookupPath: 'folder/instance/unknown') isNil.
	self assert: (self root lookupPath: 'folder/instance/unknown/') isNil! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/21/2009 18:46'!
testLookupErrorIfAbsent
	self assert: (self root lookupPath: 'unknown' ifAbsent: [ self structure ]) = self structure.
	self assert: (self root lookupPath: 'unknown/' ifAbsent: [ self structure ]) = self structure.

	self assert: (self root lookupPath: 'zork' ifAbsent: [ self structure ]) = self structure.
	self assert: (self root lookupPath: 'zork/' ifAbsent: [ self structure ]) = self structure.

	self assert: (self root lookupPath: 'folder/unknown' ifAbsent: [ self structure ]) = self structure.
	self assert: (self root lookupPath: 'folder/unknown/' ifAbsent: [ self structure ]) = self structure.

	self assert: (self root lookupPath: 'folder/unknown/unknown' ifAbsent: [ self structure ]) = self structure.
	self assert: (self root lookupPath: 'folder/unknown/unknown/' ifAbsent: [ self structure ]) = self structure.

	self assert: (self root lookupPath: 'folder/instance/unknown' ifAbsent: [ self structure ]) = self structure.
	self assert: (self root lookupPath: 'folder/instance/unknown/' ifAbsent: [ self structure ]) = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:11'!
testLookupParent
	self assert: (self root lookupPath: '..') = self root.
	self assert: (self root lookupPath: '../') = self root.

	self assert: (self folder lookupPath: '..') = self root.
	self assert: (self folder lookupPath: '../') = self root.

	self assert: (self child lookupPath: '..') = self folder.
	self assert: (self child lookupPath: '../') = self folder.

	self assert: (self structure lookupPath: '..') = self folder.
	self assert: (self structure lookupPath: '../') = self folder! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:08'!
testLookupParentParent
	self assert: (self root lookupPath: '../..') = self root.
	self assert: (self root lookupPath: '../../') = self root.

	self assert: (self folder lookupPath: '../..') = self root.
	self assert: (self folder lookupPath: '../../') = self root.

	self assert: (self child lookupPath: '../..') = self root.
	self assert: (self child lookupPath: '../../') = self root.

	self assert: (self structure lookupPath: '../..') = self root.
	self assert: (self structure lookupPath: '../..') = self root! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupParsing
	self assert: (PRPathLookup new stream: 'abc' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/' readStream; readNext) = 'abc'.

	self assert: (PRPathLookup new stream: 'abc/def' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/def/' readStream; readNext) = 'abc'.

	self assert: (PRPathLookup new stream: 'abc' readStream; readNext; readNext) = ''.
	self assert: (PRPathLookup new stream: 'abc/' readStream; readNext; readNext) = ''.

	self assert: (PRPathLookup new stream: 'abc/def' readStream; readNext; readNext) = 'def'.
	self assert: (PRPathLookup new stream: 'abc/def/' readStream; readNext; readNext) = 'def'! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:07'!
testLookupRelative
	self assert: (self structure lookupPath: '../structure') = self structure.
	self assert: (self structure lookupPath: '../structure/') = self structure.

	self assert: (self structure lookupPath: '../../folder') = self folder.
	self assert: (self structure lookupPath: '../../folder/') = self folder.

	self assert: (self structure lookupPath: '../../folder/structure') = self structure.
	self assert: (self structure lookupPath: '../../folder/structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:09'!
testLookupRelativeTitle
	self assert: (self structure lookupPath: '../Structure') = self structure.
	self assert: (self structure lookupPath: '../Structure/') = self structure.

	self assert: (self structure lookupPath: '../../Folder') = self folder.
	self assert: (self structure lookupPath: '../../Folder/') = self folder.

	self assert: (self structure lookupPath: '../../Folder/Structure') = self structure.
	self assert: (self structure lookupPath: '../../Folder/Structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:10'!
testLookupRoot
	self assert: (self root lookupPath: '/') = self root.
	self assert: (self root lookupPath: '/folder') = self folder.
	self assert: (self root lookupPath: '/folder/child') = self child.
	self assert: (self root lookupPath: '/folder/structure') = self structure.

	self assert: (self structure lookupPath: '/') = self root.
	self assert: (self structure lookupPath: '/folder') = self folder.
	self assert: (self structure lookupPath: '/folder/child') = self child.
	self assert: (self structure lookupPath: '/folder/structure') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 4/11/2009 16:06'!
testLookupRootTitle
	self assert: (self root lookupPath: '/Folder') = self folder.
	self assert: (self root lookupPath: '/Folder/Child') = self child.
	self assert: (self root lookupPath: '/Folder/Structure') = self structure.

	self assert: (self structure lookupPath: '/Folder') = self folder.
	self assert: (self structure lookupPath: '/Folder/Child') = self child.
	self assert: (self structure lookupPath: '/Folder/Structure') = self structure! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self assert: self root name = 'root'.
	self assert: self folder name = 'folder'.
	self assert: self child name = 'child'.
	self assert: self structure name = 'structure'! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 8/24/2008 11:56'!
testParent
	self assert: self root parent isNil.
	self assert: self folder parent = root.
	self assert: self child parent = folder.
	self assert: self structure parent = folder! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testParents
	self assert: self root parents size = 1.
	self assert: self root parents first = self root.

	self assert: self folder parents size = 2.
	self assert: self folder parents first = self root.
	self assert: self folder parents second = self folder.

	self assert: self child parents size = 3.
	self assert: self child parents first = self root.
	self assert: self child parents second = self folder.
	self assert: self child parents third = self child.

	self assert: self structure parents size = 3.
	self assert: self structure parents first = self root.
	self assert: self structure parents second = self folder.
	self assert: self structure parents third = self structure! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 4/11/2009 10:37'!
testReferenceEmpty
	self assert: (self root relativePathTo: self root) = '.'.
	self assert: (self folder relativePathTo: self folder) = '.'.
	self assert: (self child relativePathTo: self child) = '.'.
	self assert: (self structure relativePathTo: self structure) = '.'.
	
	self assert: (self root relativePathFrom: self root) = '.'.
	self assert: (self folder relativePathFrom: self folder) = '.'.
	self assert: (self child relativePathFrom: self child) = '.'.
	self assert: (self structure relativePathFrom: self structure) = '.'! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 4/11/2009 10:38'!
testReferenceError
	self should: [ self structure relativePathFrom: PRPage new ] raise: PRInvalidKernelError.
	self should: [ PRPage new relativePathFrom: self structure ] raise: PRInvalidKernelError.
	self should: [ self structure relativePathTo: PRPage new ] raise: PRInvalidKernelError.
	self should: [ PRPage new relativePathTo: self structure ] raise: PRInvalidKernelError! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 4/11/2009 10:40'!
testReferenceParent
	self assert: (self folder relativePathTo: self root) = '..'.
	self assert: (self child relativePathTo: self folder) = '..'.
	self assert: (self structure relativePathTo: self folder) = '..'.
	
	self assert: (self root relativePathFrom: self folder) = '..'.
	self assert: (self folder relativePathFrom: self child) = '..'.
	self assert: (self folder relativePathFrom: self structure) = '..'.

	self assert: (self child relativePathTo: self root) = '../..'.
	self assert: (self structure relativePathTo: self root) = '../..'.
	
	self assert: (self root relativePathFrom: self child) = '../..'.
	self assert: (self root relativePathFrom: self structure) = '../..'! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 4/11/2009 10:41'!
testReferenceRelative
	self assert: (self structure relativePathFrom: self child) = '../structure'.
	self assert: (self child relativePathFrom: self structure) = '../child'.
	
	self assert: (self child relativePathTo: self structure) = '../structure'.
	self assert: (self structure relativePathTo: self child) = '../child'! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 4/11/2009 10:49'!
testReferenceRoot
	self assert: (self root absolutePath) = '/'.
	self assert: (self folder absolutePath) = '/folder'.
	self assert: (self child absolutePath) = '/folder/child'.
	self assert: (self structure absolutePath) = '/folder/structure'.

	self assert: (self root relativePathTo: self root) = '.'.
	self assert: (self root relativePathTo: self folder) = 'folder'.
	self assert: (self root relativePathTo: self child) = 'folder/child'.
	self assert: (self root relativePathTo: self structure) = 'folder/structure'.
	
	self assert: (self root relativePathFrom: self root) = '.'.
	self assert: (self folder relativePathFrom: self root) = 'folder'.
	self assert: (self child relativePathFrom: self root) = 'folder/child'.
	self assert: (self structure relativePathFrom: self root) = 'folder/structure'! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	self assert: self root root = self root.
	self assert: self folder root = self root.
	self assert: self child root = self root.
	self assert: self structure root = self root! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 5/28/2007 16:31'!
testTags
	self assert: self structure tags isEmpty.
	self structure tags: #( 'foo' 'bar' ).
	self assert: (self structure tags includes: 'foo').
	self assert: (self structure tags includes: 'bar')! !

PRObjectTest subclass: #PRDecorationTest
	instanceVariableNames: 'decorated decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

PRDecorationTest subclass: #PRChildrenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Structure'!

!PRChildrenTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRChildren! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
firstChildInstance
	^ PRPage named: 'child1'! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
secondChildInstance
	^ PRPage named: 'child2'! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 3/9/2006 11:31'!
testAdd
	| child1 child2 |
	child1 := self firstChildInstance.
	self assert: (self decoration add: child1) = child1.
	self assert: self decorated = child1 parent.

	child2 := self secondChildInstance.
	self assert: (self decoration add: child2) = child2.
	self assert: self decorated = child2 parent! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAt
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 name) = child1.
	self assert: (self decoration at: child2 name) = child2.
	self should: [ self decoration at: 'zork' ] raise: Error! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAtIfAbsent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 name ifAbsent: [ nil ]) = child1.
	self assert: (self decoration at: child2 name ifAbsent: [ nil ]) = child2.
	self assert: (self decoration at: 'zork' ifAbsent: [ nil ]) isNil! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAtIfPresent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration
		at: child1 name
		ifPresent: [ :val | val ]) = child1.
	self assert: (self decoration
		at: child2 name
		ifPresent: [ :val | 'zork' ]) = 'zork'.
	self assert: (self decoration
		at: 'zork'
		ifPresent: [ :val | self assert: false ]) isNil! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testIncludes
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration includes: child1 name).
	self assert: (self decoration includes: child2 name).
	self deny: (self decoration includes: 'zork')! !

!PRChildrenTest methodsFor: 'testing-testing' stamp: 'lr 9/25/2006 08:20'!
testIsEmpty
	self assert: self decoration isEmpty.
	self decoration add: self firstChildInstance.
	self deny: self decoration isEmpty! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'TestRunner 11/15/2009 23:30'!
testRemove
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).
	self assert: (self decoration remove: child1) = child1.
	self assert: (self decoration remove: child2) = child2.
	self assert: (self decoration isEmpty).
	self assert: (self decoration decorated isNil)! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 9/25/2006 08:18'!
testRemoveLast
	"Tests that the children decoration is properly removed if the last child has been removed from the decoration."

	| child |
	self decoration
		add: (child := self firstChildInstance).
	self decoration
		remove: child.
	self decorated
		decorationOfClass: self actualClass
		ifAbsent: [ ^ self ].
	self assert: false! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:50'!
testSize
	self assert: self decoration size = 0.
	self decoration
		add: self firstChildInstance;
		add: self secondChildInstance.
	self assert: self decoration size = 2! !

!PRDecorationTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRDecoration! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass new! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decorated
	^ decorated! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
decoratedInstance
	^ PRPage new! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decoration
	^ decoration! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ decoration! !

!PRDecorationTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	decorated := self decoratedInstance.
	decoration := self actualInstance.
	decorated addDecoration: decoration! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecorated
	| ownerCopy decorationCopy |
	ownerCopy := self decorated copy.
	decorationCopy := ownerCopy decorations first.

	self deny: self decorated == ownerCopy.
	self deny: self decorated == decorationCopy.

	self assert: self decorated decorations size = 1.
	self assert: self decorated decorations first = self decoration.
	self assert: self decorated = self decoration decorated.

	self assert: ownerCopy decorations size = 1.
	self assert: ownerCopy decorations first = decorationCopy.
	self assert: ownerCopy = decorationCopy decorated! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecoration
	| decorationCopy |
	decorationCopy := self decoration copy.

	self deny: self decoration == decorationCopy.
	self assert: self decoration = decorationCopy.
	self assert: self decoration decorated = self decorated.
	self assert: decorationCopy decorated isNil! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testDecorated
	self assert: self decoration decorated = self decorated! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testPriority
	self assert: self decoration priority isNumber! !

!PRDecorationTest methodsFor: 'testing-utilities' stamp: 'lr 2/12/2007 19:07'!
testRemove
	self decoration remove.
	self assert: self decoration decorated isNil.
	self decorated
		decorationOfClass: self actualClass
		ifAbsent: [ ^ self ].
	self assert: false! !

PRObjectTest subclass: #PRDocumentItemTest
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

PRDocumentItemTest subclass: #PRAnchorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRAnchorTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRAnchorTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRAnchor! !

!PRAnchorTest methodsFor: 'testing-comparing' stamp: 'lr 4/5/2007 13:16'!
testEqualName
	self deny: (self actualClass named: 'foo') = (self actualClass named: 'bar')! !

!PRAnchorTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self instance name: 'zork'.
	self assert: self instance name = 'zork'! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 13:08'!
testParseBasic
	| wiki text tree |
	wiki := '@name'.
	text := ''.
	tree := PRDocument new
		add: (PRAnchor named: 'name');
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMultiple
	| wiki text tree |
	wiki := '@one' , (String with: Character cr) , '@two' , (String with: Character cr) , (String with: Character cr) , '@tree'.
	text := ''.
	tree := PRDocument new
		add: (PRAnchor named: 'one');
		add: (PRAnchor named: 'two');
		add: PREmptyParagraph new;
		add: (PRAnchor named: 'tree');
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 13:08'!
testParseSpaces
	| wiki text tree |
	wiki := '@one two'.
	text := ''.
	tree := PRDocument new
		add: (PRAnchor named: 'one two');
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnchorTest methodsFor: 'testing-instantiation' stamp: 'lr 4/5/2007 13:16'!
testWith
	instance := self actualClass named: 'test'.
	self assert: self instance name = 'test'! !

PRDocumentItemTest subclass: #PRDocumentGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

PRDocumentGroupTest subclass: #PRAnnotatedParagraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRAnnotatedParagraphTest class methodsFor: 'testing' stamp: 'lr 5/26/2009 22:22'!
isAbstract
	^ false! !

!PRAnnotatedParagraphTest methodsFor: 'private' stamp: 'lr 5/26/2009 22:21'!
actualClass
	^ PRAnnotatedParagraph! !

!PRAnnotatedParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 5/26/2009 22:31'!
testParseBasic
	| wiki text tree |
	wiki := '@@foo bar zork'.
	text := 'bar zork'.
	tree := PRDocument new
		add: (PRAnnotatedParagraph new
			annotation: 'foo';
			add: (PRText content: 'bar zork');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnnotatedParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 9/17/2009 18:02'!
testParseEmptyFollwedByPreformatted
	| wiki text tree |
	wiki := '@@foo' , String cr , '=bar'.
	text := String cr , 'bar'.
	tree := PRDocument new
		add: (PRAnnotatedParagraph new
			annotation: 'foo';
			yourself);
		add: (PRPreformatted new
			add: (PRText content: 'bar');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnnotatedParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 5/26/2009 22:31'!
testParseOnlyAnnotation
	| wiki text tree |
	wiki := '@@foo'.
	text := ''.
	tree := PRDocument new
		add: (PRAnnotatedParagraph new
			annotation: 'foo';
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnnotatedParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 5/26/2009 22:31'!
testParseOnlyNothing
	| wiki text tree |
	wiki := '@@'.
	text := ''.
	tree := PRDocument new
		add: (PRAnnotatedParagraph new
			annotation: '';
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRAnnotatedParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 5/26/2009 22:31'!
testParseOnlyText
	| wiki text tree |
	wiki := '@@ foo bar'.
	text := 'foo bar'.
	tree := PRDocument new
		add: (PRAnnotatedParagraph new
			add: (PRText content: 'foo bar');
			annotation: '';
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRDocumentGroupTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRDocumentGroupTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRDocumentGroup! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAdd
	self instance add: self fooInstance.
	self assert: self instance children size = 1.
	self assert: self instance children first = self fooInstance.

	self instance add: self barInstance.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAddAll
	self instance addAll: self foobarInstances.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance! !

!PRDocumentGroupTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyChildren
	self instance addAll: self foobarInstances.
	self assert: self instance children = self instance copy children.
	self deny: self instance children == self instance copy children.
	self instance children
		with: self instance copy children
		do: [ :a :b | self assert: a = b. self deny: a == b ]! !

!PRDocumentGroupTest methodsFor: 'testing-testing' stamp: 'lr 3/20/2006 19:08'!
testHasChildren
	self deny: self instance hasChildren.
	self instance add: self fooInstance.
	self assert: self instance hasChildren! !

!PRDocumentGroupTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2009 21:55'!
testSize
	self assert: self instance size = 0.
	self instance add: self fooInstance.
	self assert: self instance size = 1! !

!PRDocumentGroupTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self instance addAll: self foobarInstances.
	self assert: self instance text = 'foobar'! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWith
	instance := self actualClass with: self fooInstance.
	self assert: instance children size = 1.
	self assert: instance children first = self fooInstance! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWithAll
	instance := self actualClass withAll: self foobarInstances.
	self assert: instance children size = 2.
	self assert: instance children first = self fooInstance.
	self assert: instance children second = self barInstance! !

PRDocumentGroupTest subclass: #PRDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRDocumentTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRDocumentTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRDocument! !

!PRDocumentTest methodsFor: 'testing-parsing' stamp: 'lr 12/9/2007 17:02'!
testParseEmpty
	| wiki text tree |
	wiki := String new.
	text := String new.
	tree := PRDocument new.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

PRDocumentGroupTest subclass: #PRFormatTest
	instanceVariableNames: 'otherClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

PRFormatTest subclass: #PRBoldFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRBoldFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRBoldFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRBoldFormat! !

!PRFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRFormat! !

!PRFormatTest methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:08'!
otherClass
	^ otherClass ifNil: [ otherClass := PRFormat allSubclasses detect: [ :each | self actualClass ~= each ] ]! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 15:37'!
testParseBasic
	| wiki text tree |
	wiki := '1' , self actualClass markup , '2' , self actualClass markup , '3'.
	text := '123'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '1');
			add: (self actualClass with: (PRText content: '2'));
			add: (PRText content: '3');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:32'!
testParseEnd
	| wiki text tree |
	wiki := '1' , self actualClass markup , '2' , self actualClass markup.
	text := '12'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '1');
			add: (self actualClass with: (PRText content: '2'));
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 15:57'!
testParseEscaped
	| wiki text tree |
	wiki := ' \' , self actualClass markup , '\' , self actualClass markup.
	text := ' ' , self actualClass markup , self actualClass markup.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: ' ' , self actualClass markup , self actualClass markup);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 15:47'!
testParseIncomplete
	| wiki1 wiki2 text tree |
	wiki1 := '1' , self actualClass markup , '2'.
	wiki2 := '1\' , self actualClass markup , '2'.
	text := '1' , self actualClass markup , '2'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '1' , self actualClass markup , '2');
			yourself);
		yourself.
	self assertWiki: wiki1 equalsTree: tree.
	self assertWiki: wiki2 equalsTree: tree.
	self assertTree: tree equalsWiki: wiki2.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:32'!
testParseMany
	| wiki text tree |
	wiki := '1' , self actualClass markup , '2' , self actualClass markup , '3' , self actualClass markup , '4' , self actualClass markup , '5'.
	text := '12345'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '1');
			add: (self actualClass with: (PRText content: '2'));
			add: (PRText content: '3');
			add: (self actualClass with: (PRText content: '4'));
			add: (PRText content: '5');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 16:06'!
testParseNested
	| wiki text tree |
	wiki := '1' , self actualClass markup , '2' , self otherClass markup , '3' , self otherClass markup , '4' , self actualClass markup , '5'.
	text := '12345'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '1');
			add: (self actualClass new
				add: (PRText content: '2');
				add: (self otherClass new
					add: (PRText content: '3');
					yourself);
				add: (PRText content: '4');
				yourself);
			add: (PRText content: '5');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRFormatTest methodsFor: 'testing-parsing' stamp: 'lr 12/20/2007 14:36'!
testParseNestedTight
	| wiki text tree |
	wiki := ' ' , self actualClass markup , self otherClass markup , self otherClass markup , self actualClass markup.
	text := ' '.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: ' ');
			add: (self actualClass new
				add: self otherClass new
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

PRFormatTest subclass: #PRItalicFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRItalicFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRItalicFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRItalicFormat! !

PRFormatTest subclass: #PRMonospaceFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRMonospaceFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRMonospaceFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRMonospaceFormat! !

PRFormatTest subclass: #PRStrikethroughFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRStrikethroughFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRStrikethroughFormatTest methodsFor: 'private' stamp: 'lr 5/31/2007 07:48'!
actualClass
	^ PRStrikethroughFormat! !

PRFormatTest subclass: #PRSubscriptFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRSubscriptFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRSubscriptFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRSubscriptFormat! !

PRFormatTest subclass: #PRSuperscriptFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRSuperscriptFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRSuperscriptFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRSuperscriptFormat! !

PRFormatTest subclass: #PRUnderlineFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRUnderlineFormatTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRUnderlineFormatTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRUnderlineFormat! !

PRDocumentGroupTest subclass: #PRHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRHeaderTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRHeaderTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRHeader! !

!PRHeaderTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualLevel
	self deny: (self actualClass new level: 1) = (self actualClass new level: 2)! !

!PRHeaderTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self instance level: 3.
	self assert: self instance level = 3! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 10/18/2007 19:22'!
testParseEmpty
	| wiki text tree |
	wiki := '!!'.
	text := ''.
	tree := PRDocument new
		add: (PRHeader new
			level: 1;
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel1
	| wiki text tree |
	wiki := '!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 1;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel2
	| wiki text tree |
	wiki := '!!!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 2;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel3
	| wiki text tree |
	wiki := '!!!!!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 3;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel4
	| wiki text tree |
	wiki := '!!!!!!!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 4;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel5
	| wiki text tree |
	wiki := '!!!!!!!!!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 5;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseLevel6
	| wiki text tree |
	wiki := '!!!!!!!!!!!!foo'.
	text := 'foo'.
	tree := PRDocument new
		add: ((PRHeader new)
			level: 6;
			add: (PRText content: 'foo');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseNested
	| wiki text tree |
	wiki := '!!!!Hello *Link*'.
	text := 'Hello Link'.
	tree := PRDocument new
		add: (PRHeader new
			level: 2;
			add: (PRText content: 'Hello ');
			add: (PRInternalLink new
				reference: 'Link';
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHeaderTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWithAllLevel
	instance := self actualClass withAll: self foobarInstances level: 3.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.
	self assert: self instance level = 3! !

PRDocumentGroupTest subclass: #PRLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

PRLinkTest subclass: #PRExternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRExternalLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRExternalLink! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'http://www.lukas-renggli.ch'! !

!PRExternalLinkTest methodsFor: 'as yet unclassified' stamp: 'lr 4/1/2009 22:29'!
testIsExternal
	self assert: self instance isExternal! !

!PRExternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 12:06'!
testTitle
	self instance reference: 'http://www.lukas-renggli.ch'.
	self assert: self instance title = 'http://www.lukas-renggli.ch'! !

!PRExternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testUrl
	self instance reference: 'http://www.lukas-renggli.ch'.
	self assert: self instance url = 'http://www.lukas-renggli.ch'! !

PRExternalLinkTest subclass: #PRMailLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRMailLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRMailLink! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:15'!
referenceString
	^ 'renggli@gmail.com'! !

!PRMailLinkTest methodsFor: 'testing-parsing' stamp: 'lr 9/22/2008 08:25'!
testParseBogus
	| wiki text tree |
	wiki := '*ab12@x.com*'.
	text := 'ab12@x.com'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: 'ab12@x.com';
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRMailLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:16'!
testTitle
	super testTitle.
	self instance reference: self referenceString.
	self assert: self instance title = self referenceString! !

!PRMailLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 15:01'!
testUrl
	self instance reference: self referenceString.
	self assert: (self instance url beginsWith: 'mailto:').
	self assert: self instance url ~= ('mailto:' , self referenceString)! !

PRLinkTest subclass: #PRInternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRInternalLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRInternalLink! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'Page'! !

!PRInternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAnchor
	self instance anchor: 'zork'.
	self assert: self instance anchor = 'zork'.
	self assert: self instance hasAnchor! !

!PRInternalLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualAnchor
	self deny: (self actualClass new anchor: 'foo'; yourself) = ((self actualClass new) anchor: 'bar'; yourself)! !

!PRInternalLinkTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:35'!
testIsInternal
	self assert: self instance isInternal! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 2/7/2007 15:18'!
testParseAnchoredEmbedded
	| wiki text tree |
	wiki := '+' , self referenceString , '@Anchor+'.
	text := self actualClass new
		reference: self referenceString;
		anchor: 'Anchor';
		embedded: true;
		title.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				anchor: 'Anchor';
				embedded: true;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 2/7/2007 15:17'!
testParseAnchoredReferenced
	| wiki text tree |
	wiki := '*' , self referenceString , '@Anchor*'.
	text := self actualClass new
		reference: self referenceString;
		anchor: 'Anchor';
		title.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				anchor: 'Anchor';
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseEverything
	| wiki text tree |
	wiki := '*Alias>' , self referenceString , '@Anchor*'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				anchor: 'Anchor';
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRInternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 11:45'!
testTitle
	super testTitle.
	self instance reference: 'page'.
	self assert: self instance title = 'page'! !

!PRLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRLink! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	self subclassResponsibility! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAlias
	self deny: self instance hasAlias.

	self instance add: self fooInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foo'.

	self instance add: self barInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foobar'! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAnchor
	self deny: self instance hasAnchor! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testEmbedded
	self instance embedded: true.
	self assert: self instance isEmbedded.

	self instance embedded: false.
	self deny: self instance isEmbedded! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualEmbedded
	self deny: (self actualClass new embedded: false; yourself) = (self actualClass new embedded: true; yourself)! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualReference
	self deny: (self actualClass new reference: 'foo'; yourself) = (self actualClass new reference: 'bar'; yourself)! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 10/9/2008 12:10'!
testHasParameter
	self instance parameters: (Array with: 'foo' -> 'zork' with: 'bar' -> nil).
	self assert: (self instance hasParameter: 'foo').
	self assert: (self instance hasParameter: 'bar').
	self deny: (self instance hasParameter: 'zork')! !

!PRLinkTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:35'!
testIsBroken
	self assert: (self instance isBroken or: [ self instance isBroken not ])! !

!PRLinkTest methodsFor: 'testing' stamp: 'lr 4/1/2009 22:28'!
testIsExternal
	self deny: self instance isExternal! !

!PRLinkTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:35'!
testIsInternal
	self deny: self instance isInternal! !

!PRLinkTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:36'!
testIsLink
	self assert: self instance isLink! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 9/8/2008 17:20'!
testParameterAt
	self instance parameters: (Array with: 'foo' -> 'bar').
	self assert: (self instance parameterAt: 'foo') = 'bar'.
	self assert: (self instance parameterAt: 'bar') isNil! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 9/8/2008 17:20'!
testParameterAtIfAbsent
	self instance parameters: (Array with: 'foo' -> 'bar').
	self assert: (self instance parameterAt: 'foo' ifAbsent: [ 'zork' ]) = 'bar'.
	self assert: (self instance parameterAt: 'bar'  ifAbsent: [ 'zork' ]) = 'zork'! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 3/30/2009 21:53'!
testParameterAtIfPresent
	self instance parameters: (Array with: 'foo' -> 'bar').
	self assert: (self instance parameterAt: 'foo' ifPresent: [ :value | '!!' , value ]) = '!!bar'.
	self assert: (self instance parameterAt: 'bar' ifPresent: [ :value | '!!' , value ]) isNil! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 1/30/2009 20:17'!
testParameterAtPut
	self assert: (self instance parameterAt: 'foo' put: 'bar') = 'bar'.
	self assert: (self instance parameters size = 1).
	self assert: (self instance parameters first key = 'foo').
	self assert: (self instance parameters first value = 'bar').
	
	self assert: (self instance parameterAt: 'foo' put: 'zork') = 'zork'.
	self assert: (self instance parameters size = 1).
	self assert: (self instance parameters first key = 'foo').
	self assert: (self instance parameters first value = 'zork')! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 4/4/2009 11:55'!
testParameterCopy
	| copy |
	self instance parameterAt: 'class' put: 'active'.
	copy := self instance copy.
	copy parameterAt: 'class' put: 'inactive'.
	copy parameterAt: 'foo' put: 'bar'.
	
	self assert: (self instance parameterAt: 'class') = 'active'.
	self deny: (self instance hasParameter: 'foo').
	
	self assert: (copy parameterAt: 'class') = 'inactive'.
	self assert: (copy parameterAt: 'foo') = 'bar'! !

!PRLinkTest methodsFor: 'testing-parameters' stamp: 'lr 8/27/2007 10:22'!
testParameters
	self assert: self instance parameters isEmpty.
	self instance parameters: (Array with: 'foo' -> 'bar').
	self assert: self instance parameters size = 1! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseAliased
	| wiki text tree |
	wiki := '*Alias>' , self referenceString , '*'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2009 16:01'!
testParseAliasedEmpty
	| wiki text tree |
	wiki := '*>' , self referenceString , '*'.
	text := ''.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: '');
				reference: self referenceString;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 2/7/2007 15:06'!
testParseBasic
	| wiki text tree |
	wiki := '*' , self referenceString , '*'.
	text := self actualClass new
		reference: self referenceString;
		title.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseEasynessEmbedded
	| wiki1 wiki2 text tree |
	wiki1 := '+' , (String with: Character cr) , '+' , self referenceString.
	wiki2 := '\+' , (String with: Character cr) , '\+' , self referenceString.
	text := '+' , (String with: Character cr) , '+' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: '+');
				add: PRLineBreak new;
				add: (PRText content: '+' , self referenceString);
				yourself);
		yourself.
	self 
		assertWiki: wiki1
		equalsTree: tree.
	self 
		assertWiki: wiki2
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki2.
	self 
		assertTree: tree
		equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseEasynessReferenced
	| wiki1 wiki2 text tree |
	wiki1 := '*' , (String with: Character cr) , '*' , self referenceString.
	wiki2 := '\*' , (String with: Character cr) , '\*' , self referenceString.
	text := '*' , (String with: Character cr) , '*' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: '*');
				add: PRLineBreak new;
				add: (PRText content: '*' , self referenceString);
				yourself);
		yourself.
	self 
		assertWiki: wiki1
		equalsTree: tree.
	self 
		assertWiki: wiki2
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki2.
	self 
		assertTree: tree
		equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseEmbeddedAliased
	| wiki text tree |
	wiki := '+Alias>' , self referenceString , '+'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				embedded: true;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 2/7/2007 15:10'!
testParseEmbeddedBasic
	| wiki text tree |
	wiki := '+' , self referenceString , '+'.
	text := self actualClass new
		reference: self referenceString;
		embedded: true;
		title.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				embedded: true;
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseEscaped
	| wiki text tree |
	wiki := 'Star \*' , self referenceString , '\*' , (String with: Character cr) , 'Cross \+' , self referenceString , '\+'.
	text := 'Star *' , self referenceString , '*' , (String with: Character cr) , 'Cross +' , self referenceString , '+'.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Star *' , self referenceString , '*');
				add: PRLineBreak new;
				add: (PRText content: 'Cross +' , self referenceString , '+');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/21/2009 13:54'!
testParseParameters
	| wiki text tree |
	wiki := '*Alias>' , self referenceString , '|a=1|b=2|c*'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				parameters: (Array
					with: 'a' -> '1'
					with: 'b' -> '2'
					with: 'c' -> nil);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 9/12/2007 18:18'!
testParseParametersEmpty
	| wiki text tree |
	wiki := '*Alias>' , self referenceString , '|a||b|*'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				parameters: (Array
					with: 'a' -> nil
					with: 'b' -> nil);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'TestRunner 12/21/2009 13:58'!
testParseParametersEscaped
	| wiki text tree |
	wiki := '*Alias>' , self referenceString , '|\|\==1|2=\|\=*'.
	text := 'Alias'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText content: 'Alias');
				reference: self referenceString;
				parameters: (Array
					with: '|=' -> '1'
					with: '2' -> '|=');
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testReference
	self instance reference: 'zork'.
	self assert: self instance reference = 'zork'! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 11:43'!
testTitle
	self deny: self instance title notNil! !

PRLinkTest subclass: #PRValueLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRValueLinkTest class methodsFor: 'testing' stamp: 'lr 1/9/2009 20:28'!
isAbstract
	^ false! !

!PRValueLinkTest methodsFor: 'private' stamp: 'lr 1/9/2009 20:27'!
actualClass
	^ PRValueLink! !

!PRValueLinkTest methodsFor: 'private' stamp: 'lr 1/13/2009 20:13'!
referenceString
	^ 'value:structure'! !

!PRValueLinkTest methodsFor: 'testing' stamp: 'lr 1/13/2009 20:13'!
testBroken
	self assert: self instance isBroken.
	
	self instance reference: 'value:does-not-exist'.
	self assert: self instance isBroken.
	
	self instance reference: 'value:STRUCTURE'.
	self deny: self instance isBroken.
	
	self instance reference: 'value:structure'.
	self deny: self instance isBroken.
	
	self instance reference: 'value:  structure'.
	self deny: self instance isBroken.
	
	self instance reference: 'value:structure  '.
	self deny: self instance isBroken! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 4/22/2009 15:16'!
testFilterReject
	self instance parameterAt: 'reject' put: 'Page'.
	self assert: (self instance selectAndReject: PRPage new) isNil.
	self assert: (self instance selectAndReject: PRFile new) notNil.	! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 4/22/2009 15:16'!
testFilterSelect
	self instance parameterAt: 'select' put: 'Page'.
	self assert: (self instance selectAndReject: PRPage new) notNil.
	self assert: (self instance selectAndReject: PRFile new) isNil! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 4/22/2009 13:07'!
testFormatStructure
	| structure context document |
	structure := PRPage named: 'foo'.
	context := PRContext kernel: PRKernel basicNew structure: structure.

	self instance reference: 'value:structure'.
	document := self instance formatStructure: structure in: context.
	self assert: document text = 'Foo'.

	self instance parameterAt: 'display' put: 'name'.
	document := self instance formatStructure: structure in: context.
	self assert: document text = 'foo'.
	
	self instance parameterAt: 'link' put: nil.
	document := self instance formatStructure: structure in: context.
	self assert: document target = structure.
	self assert: document children first text = 'foo'! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 2/2/2009 22:16'!
testLookupStructure
	| structure1 structure2 structure3 |
	structure1 := PRPage named: '1'.
	structure2 := PRPage named: '2'.
	structure3 := PRPage named: '3'.

	structure1 addChild: structure2.
	structure2 addChild: structure3.
	
	self instance reference: 'value:structure'.

	self instance parameterAt: 'level' put: '-3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure1.
	
	self instance parameterAt: 'level' put: '-1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '0'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure1.
	
	self instance parameterAt: 'level' put: '2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '4'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 2/2/2009 22:19'!
testLookupStructureLower
	| structure1 structure2 structure3 |
	structure1 := PRPage named: '1'.
	structure2 := PRPage named: '2'.
	structure3 := PRPage named: '3'.

	structure1 addChild: structure2.
	structure2 addChild: structure3.
	
	self instance reference: 'value:structure'.
	self instance parameterAt: 'lower' put: '2'.

	self instance parameterAt: 'level' put: '-3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '0'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '4'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 2/2/2009 22:19'!
testLookupStructureUpper
	| structure1 structure2 structure3 |
	structure1 := PRPage named: '1'.
	structure2 := PRPage named: '2'.
	structure3 := PRPage named: '3'.

	structure1 addChild: structure2.
	structure2 addChild: structure3.
	
	self instance reference: 'value:structure'.
	self instance parameterAt: 'upper' put: '2'.

	self instance parameterAt: 'level' put: '-3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure1.
	
	self instance parameterAt: 'level' put: '-1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '0'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure1.
	
	self instance parameterAt: 'level' put: '2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '4'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil! !

!PRValueLinkTest methodsFor: 'testing-utilities' stamp: 'lr 4/22/2009 15:15'!
testSelectAndReject
	| structure1 structure2 structure3 |
	structure1 := PRPage named: '1'.
	structure2 := PRPage named: '2'.
	structure3 := PRPage named: '3'.

	structure1 addChild: structure2.
	structure2 addChild: structure3.
	
	self instance reference: 'value:structure'.
	self instance parameterAt: 'lower' put: '2'.

	self instance parameterAt: 'level' put: '-3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '-1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '0'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '1'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil.
	
	self instance parameterAt: 'level' put: '2'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure2.
	
	self instance parameterAt: 'level' put: '3'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) = structure3.
	
	self instance parameterAt: 'level' put: '4'.
	self assert: (self instance lookupStructure: structure3 do: [ :structure | structure ]) isNil! !

!PRValueLinkTest methodsFor: 'testing' stamp: 'lr 1/13/2009 20:13'!
testSelectorFor
	self assert: (self instance selectorFor: 'date') = #dateIn:.
	self assert: (self instance selectorFor: 'context') = #contextIn:! !

!PRValueLinkTest methodsFor: 'testing' stamp: 'lr 3/30/2009 22:13'!
testSmoke
	| context |
	context := self contextInstance.
	self instance pragmas do: [ :pragma |
		self instance reference: 'value:' , pragma arguments first.
		self assert: self instance title = pragma arguments first.
		self
			shouldnt: [ self instance valueIn: context ]
			raise: Error ]! !

!PRValueLinkTest methodsFor: 'testing' stamp: 'lr 2/2/2009 21:46'!
testTitle
	self instance reference: 'value:structure'.
	self assert: self instance title = 'structure'! !

PRDocumentGroupTest subclass: #PRListItemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRListItemTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRListItemTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRListItem! !

PRDocumentGroupTest subclass: #PRListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

PRListTest subclass: #PRDefinitionDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRDefinitionDataTest class methodsFor: 'testing' stamp: 'lr 12/30/2007 21:37'!
isAbstract
	^ false! !

!PRDefinitionDataTest methodsFor: 'private' stamp: 'lr 12/30/2007 21:37'!
actualClass
	^ PRDefinitionList! !

!PRDefinitionDataTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:30'!
listItemClass
	^ PRDataItem! !

!PRDefinitionDataTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testParseBug
	| wiki1 wiki2 tree |
	wiki1 := '::1' , (String with: Character cr) , '::-2'.
	wiki2 := ':' , (String with: Character cr) , '::1' , (String with: Character cr) , '::-2'.
	tree := PRDocument new
		add: (PRDefinitionList new
				add: (PRDataItem new
						add: (PRDefinitionList new
								add: (PRDataItem new
										add: (PRText content: '1');
										add: (PRUnorderedList new
												add: (PRListItem new
														add: (PRText content: '2');
														yourself);
												yourself);
										yourself);
								yourself);
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki1
		equalsTree: tree.
	self 
		assertWiki: wiki2
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki2! !

!PRDefinitionDataTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testParseMixed
	| wiki tree |
	wiki := ';1' , (String with: Character cr) , ':2'.
	tree := PRDocument new
		add: (PRDefinitionList new
				add: (PRTermItem new
						add: (PRText content: '1');
						yourself);
				add: (PRDataItem new
						add: (PRText content: '2');
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki! !

!PRDefinitionDataTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:33'!
textString: anObject level: anInteger
	^ (super textString: anObject level: anInteger) , '  '! !

!PRDefinitionDataTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:30'!
wikiString
	^ ':'! !

PRListTest subclass: #PRDefinitionTermTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRDefinitionTermTest class methodsFor: 'testing' stamp: 'lr 12/30/2007 23:29'!
isAbstract
	^ false! !

!PRDefinitionTermTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:29'!
actualClass
	^ PRDefinitionList! !

!PRDefinitionTermTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:30'!
listItemClass
	^ PRTermItem! !

!PRDefinitionTermTest methodsFor: 'testing' stamp: 'jf 11/2/2009 10:39'!
testParseMixed
	| wiki tree |
	wiki := ';1' , (String with: Character cr) , ';2' , (String with: Character cr) , ':3' , (String with: Character cr) , ':4'.
	tree := PRDocument new
		add: (PRDefinitionList new
				add: (PRTermItem new
						add: (PRText content: '1');
						yourself);
				add: (PRTermItem new
						add: (PRText content: '2');
						yourself);
				add: (PRDataItem new
						add: (PRText content: '3');
						yourself);
				add: (PRDataItem new
						add: (PRText content: '4');
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki! !

!PRDefinitionTermTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:33'!
textString: anObject level: anInteger
	^ (super textString: anObject level: anInteger) , '- '! !

!PRDefinitionTermTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:29'!
wikiString
	^ ';'! !

!PRListTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRListTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRList! !

!PRListTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:28'!
listItemClass
	^ PRListItem! !

!PRListTest methodsFor: 'private' stamp: 'lr 12/30/2007 23:28'!
listItemWithText: aString
	^ self listItemClass new
		add: (PRText content: aString);
		yourself! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/30/2007 23:31'!
testParseEmpty
	| wiki text tree |
	wiki := self wikiString.
	text := self textString: 1 level: 1.
	tree := PRDocument new
		add: (self actualClass new
			add: self listItemClass new;
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseFlat
	| wiki text tree |
	wiki := self wikiString , '1st' , (String with: Character cr) , self wikiString , '2nd' , (String with: Character cr) , self wikiString , '3rd'.
	text := (self 
		textString: 1
		level: 1) , '1st' , (String with: Character cr) , (self 
			textString: 2
			level: 1) , '2nd' , (String with: Character cr) , (self 
			textString: 3
			level: 1) , '3rd'.
	tree := PRDocument new
		add: (self actualClass new
				add: (self listItemWithText: '1st');
				add: (self listItemWithText: '2nd');
				add: (self listItemWithText: '3rd');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMultiple
	| wiki text tree |
	wiki := self wikiString , '1st' , (String with: Character cr) , self wikiString , '2nd' , (String with: Character cr) , (String with: Character cr) , self wikiString , '3rd'.
	text := (self 
		textString: 1
		level: 1) , '1st' , (String with: Character cr) , (self 
			textString: 2
			level: 1) , '2nd' , (String with: Character cr) , (String with: Character cr) , (self 
			textString: 1
			level: 1) , '3rd'.
	tree := PRDocument new
		add: (self actualClass new
				add: (self listItemWithText: '1st');
				add: (self listItemWithText: '2nd');
				yourself);
		add: PREmptyParagraph new;
		add: (self actualClass new
				add: (self listItemWithText: '3rd');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRListTest methodsFor: 'private' stamp: 'lr 12/20/2007 23:21'!
textString: anObject level: anInteger
	^ (2 to: anInteger) inject: '' into: [ :result :each | result , '	' ]! !

!PRListTest methodsFor: 'private' stamp: 'lr 2/7/2007 16:22'!
wikiString
	self subclassResponsibility! !

PRListTest subclass: #PROrderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PROrderedListTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PROrderedList! !

!PROrderedListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMixed
	| wiki tree |
	wiki := '#1' , (String with: Character cr) , '#2' , (String with: Character cr) , '-3'.
	tree := PRDocument new
		add: (PROrderedList new
				add: (self listItemWithText: '1');
				add: (self listItemWithText: '2');
				yourself);
		add: (PRUnorderedList new
				add: (self listItemWithText: '3');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki! !

!PROrderedListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseNested
	| wiki text tree |
	wiki := self wikiString , '1' , (String with: Character cr) , self wikiString , self wikiString , '1.1' , (String with: Character cr) , self wikiString , self wikiString , '1.2'.
	text := (self 
		textString: 1
		level: 1) , '1' , (String with: Character cr) , (self 
			textString: 1
			level: 2) , '1.1' , (String with: Character cr) , (self 
			textString: 2
			level: 2) , '1.2'.
	tree := PRDocument new
		add: (self actualClass new
				add: (PRListItem new
						add: (PRText content: '1');
						add: (self actualClass new
								add: (self listItemWithText: '1.1');
								add: (self listItemWithText: '1.2');
								yourself);
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PROrderedListTest methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
textString: anObject level: anInteger 
	^ (super 
		textString: anObject
		level: anInteger) , anObject greaseString , '. '! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 12/20/2007 20:13'!
wikiString
	^ '#'! !

PRListTest subclass: #PRUnorderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRUnorderedListTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRUnorderedList! !

!PRUnorderedListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMixed
	| wiki tree text |
	wiki := '#1' , (String with: Character cr) , '##2' , (String with: Character cr) , '###3' , (String with: Character cr) , '#-4' , (String with: Character cr) , '#-5' , (String with: Character cr) , '##6' , (String with: Character cr) , '#7'.
	text := '1. 1' , (String with: Character cr) , '	1. 2' , (String with: Character cr) , '		1. 3' , (String with: Character cr) , '	* 4' , (String with: Character cr) , '	* 5' , (String with: Character cr) , '	1. 6' , (String with: Character cr) , '2. 7'.
	tree := PRDocument new
		add: (PROrderedList new
				add: (PRListItem new
						add: (PRText content: '1');
						add: (PROrderedList new
								add: (PRListItem new
										add: (PRText content: '2');
										add: (PROrderedList new
												add: (self listItemWithText: '3');
												yourself);
										yourself);
								yourself);
						add: (PRUnorderedList new
								add: (self listItemWithText: '4');
								add: (self listItemWithText: '5');
								yourself);
						add: (PROrderedList new
								add: (self listItemWithText: '6');
								yourself);
						yourself);
				add: (self listItemWithText: '7');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRUnorderedListTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseNested
	| wiki text tree |
	wiki := self wikiString , '1' , (String with: Character cr) , self wikiString , self wikiString , '1.1' , (String with: Character cr) , self wikiString , self wikiString , self wikiString , '1.1.1'.
	text := (self 
		textString: 1
		level: 1) , '1' , (String with: Character cr) , (self 
			textString: 1
			level: 2) , '1.1' , (String with: Character cr) , (self 
			textString: 1
			level: 3) , '1.1.1'.
	tree := PRDocument new
		add: (self actualClass new
				add: (PRListItem new
						add: (PRText content: '1');
						add: (self actualClass new
								add: (PRListItem new
										add: (PRText content: '1.1');
										add: (self actualClass new
												add: (self listItemWithText: '1.1.1');
												yourself);
										yourself);
								yourself);
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 12/20/2007 23:20'!
textString: anObject level: anInteger
	^ (super textString: anObject level: anInteger) , '* '! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 2/7/2007 16:23'!
wikiString
	^ '-'! !

PRDocumentGroupTest subclass: #PRParagraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRParagraphTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRParagraphTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRParagraph! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseEmptyLineAtBeginning
	| wiki text tree |
	wiki := '' , (String with: Character cr) , 'Lorem ipsum dolor sit amet.'.
	text := wiki.
	tree := PRDocument new
		add: PREmptyParagraph new;
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 12/9/2007 09:38'!
testParseOneLine
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: wiki);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTreeEmptyLines
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , (String with: Character cr) , (String with: Character cr) , 'Nulla mattis elementum nulla.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				yourself);
		add: PREmptyParagraph new;
		add: PREmptyParagraph new;
		add: (PRParagraph new
				add: (PRText content: 'Nulla mattis elementum nulla.');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTwoEmptyLines
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , (String with: Character cr) , (String with: Character cr) , 'Nulla mattis elementum nulla.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				yourself);
		add: PREmptyParagraph new;
		add: PREmptyParagraph new;
		add: (PRParagraph new
				add: (PRText content: 'Nulla mattis elementum nulla.');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

PRDocumentGroupTest subclass: #PRPreformattedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRPreformattedTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRPreformattedTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRPreformatted! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseBasic
	| wiki text tree |
	wiki := '=Line'.
	text := 'Line'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText content: 'Line');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 10/18/2007 19:43'!
testParseEmpty
	| wiki text tree |
	wiki := '='.
	text := ''.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText content: '');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMultiple
	| wiki text tree |
	wiki := '=line 1.1' , (String with: Character cr) , '=line 1.2' , (String with: Character cr) , (String with: Character cr) , '=line 2.1'.
	text := 'line 1.1' , (String with: Character cr) , 'line 1.2' , (String with: Character cr) , (String with: Character cr) , 'line 2.1'.
	tree := PRDocument new
		add: (PRPreformatted new
				add: (PRText content: 'line 1.1');
				add: (PRText content: 'line 1.2');
				yourself);
		add: PREmptyParagraph new;
		add: (PRPreformatted new
				add: (PRText content: 'line 2.1');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseSpaces
	| wiki text tree |
	wiki := '=   A line with 3 spaces' , (String with: Character cr) , '=	A line with a tab'.
	text := '   A line with 3 spaces' , (String with: Character cr) , '	A line with a tab'.
	tree := PRDocument new
		add: (PRPreformatted new
				add: (PRText content: '   A line with 3 spaces');
				add: (PRText content: '	A line with a tab');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseSpecials
	| wiki text tree |
	wiki := '=|, {, }, *, *, [, ||, |{, |}, +, +'.
	text := '|, {, }, *, *, [, ||, |{, |}, +, +'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText content: '|, {, }, *, *, [, ||, |{, |}, +, +');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

PRDocumentGroupTest subclass: #PRTableCellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRTableCellTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRTableCellTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRTableCell! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAlign
	self instance align: #right.
	self assert: self instance align = #right! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedCenter
	self instance beAlignedCenter.
	self assert: self instance align = #center.
	self assert: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self deny: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedLeft
	self instance beAlignedLeft.
	self assert: self instance align = #left.
	self deny: self instance isAlignedCenter.
	self assert: self instance isAlignedLeft.
	self deny: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedRight
	self instance beAlignedRight.
	self assert: self instance align = #right.
	self deny: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self assert: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualAlign
	self deny: self actualClass new beAlignedRight
				= self actualClass new beAlignedCenter.
	self deny: self actualClass new beAlignedCenter
				= self actualClass new beAlignedLeft! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 8/14/2008 08:59'!
testHeading
	self deny: self instance heading.
	self deny: self instance isHeading.
	
	self instance heading: true.
	self assert: self instance heading.
	self assert: self instance isHeading.
	
	self instance heading: false.
	self deny: self instance heading.
	self deny: self instance isHeading! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseAlign1
	| wiki text tree |
	wiki := '|{left||center|}right'.
	text := 'left	center	right'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText content: 'left');
					yourself);
				add: (PRTableCell new
					beAlignedCenter;
					add: (PRText content: 'center');
					yourself);
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText content: 'right');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseAlign2
	| wiki text tree |
	wiki := '|}right|none|{left|none'.
	text := 'right	none	left	none'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText content: 'right');
					yourself);
				add: (PRTableCell new
					add: (PRText content: 'none');
					yourself);
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText content: 'left');
					yourself);
				add: (PRTableCell new
					add: (PRText content: 'none');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseEncoding
	| wiki text tree |
	wiki := '|*link*|+embedded+|foo{}'.
	text := 'link	embedded	foo{}'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'link';
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'embedded';
						embedded: true;
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRText content: 'foo{}');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 8/14/2008 09:17'!
testParseHeading1
	| wiki text tree |
	wiki := '|!!head|{!!left||!!center|}!!right'.
	text := 'head	left	center	right'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beHeading;
					add: (PRText content: 'head');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedLeft;
					add: (PRText content: 'left');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedCenter;
					add: (PRText content: 'center');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedRight;
					add: (PRText content: 'right');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 8/14/2008 09:17'!
testParseHeading2
	| wiki1 wiki2 text tree |
	wiki1 := '|!!head|!!{left|!!|center|!!}right'.
	wiki2 := '|!!head|{!!left||!!center|}!!right'.
	text := 'head	left	center	right'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beHeading;
					add: (PRText content: 'head');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedLeft;
					add: (PRText content: 'left');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedCenter;
					add: (PRText content: 'center');
					yourself);
				add: (PRTableCell new
					beHeading;
					beAlignedRight;
					add: (PRText content: 'right');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki1 equalsTree: tree.
	self assertTree: tree equalsWiki: wiki2.
	self assertTree: tree equalsText: text! !

PRDocumentGroupTest subclass: #PRTableRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRTableRowTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRTableRowTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRTableRow! !

!PRTableRowTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testCount
	self instance add: PRTableCell new.
	self assert: self instance columnCount = 1.

	self instance add: PRTableCell new.
	self assert: self instance columnCount = 2! !

PRDocumentGroupTest subclass: #PRTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRTableTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRTableTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRTable! !

!PRTableTest methodsFor: 'accessing' stamp: 'lr 12/21/2009 16:56'!
expectedFailures
	^ #(testParseWithPreformattedAndLinkWithParameters)! !

!PRTableTest methodsFor: 'testing-accessing' stamp: 'lr 3/21/2006 18:43'!
testCount
	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 1; assert: self instance columnCount = 1.

	self instance add: (PRTableRow new add: PRTableCell new; add: PRTableCell new; yourself).
	self assert: self instance rowCount = 2; assert: self instance columnCount = 2.

	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 3; assert: self instance columnCount = 2! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:34'!
testParseBasic
	| wiki text tree |
	wiki := '|cell'.
	text := 'cell'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText content: 'cell');
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseSquare
	| wiki text tree |
	wiki := '|a11|a12' , (String with: Character cr) , '|a21|a22'.
	text := 'a11	a12' , (String with: Character cr) , 'a21	a22'.
	tree := PRDocument new
		add: (PRTable new
				add: (PRTableRow new
						add: (PRTableCell new
								add: (PRText content: 'a11');
								yourself);
						add: (PRTableCell new
								add: (PRText content: 'a12');
								yourself);
						yourself);
				add: (PRTableRow new
						add: (PRTableCell new
								add: (PRText content: 'a21');
								yourself);
						add: (PRTableCell new
								add: (PRText content: 'a22');
								yourself);
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTriangle
	| wiki text tree |
	wiki := '|a11' , (String with: Character cr) , '|a21|a22' , (String with: Character cr) , '|a31|a32|a33'.
	text := 'a11' , (String with: Character cr) , 'a21	a22' , (String with: Character cr) , 'a31	a32	a33'.
	tree := PRDocument new
		add: (PRTable new
				add: (PRTableRow new
						add: (PRTableCell new
								add: (PRText content: 'a11');
								yourself);
						yourself);
				add: (PRTableRow new
						add: (PRTableCell new
								add: (PRText content: 'a21');
								yourself);
						add: (PRTableCell new
								add: (PRText content: 'a22');
								yourself);
						yourself);
				add: (PRTableRow new
						add: (PRTableCell new
								add: (PRText content: 'a31');
								yourself);
						add: (PRTableCell new
								add: (PRText content: 'a32');
								yourself);
						add: (PRTableCell new
								add: (PRText content: 'a33');
								yourself);
						yourself);
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'damiencassou 7/23/2009 16:35'!
testParseWithPreformattedAndLinkWithParameters
	| wiki tree |
	wiki := '|==\+link\|a\+==|'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRMonospaceFormat new
						add: (PRText content: '+link|a+');
						yourself);
					yourself);
				add: (PRTableCell new
					yourself);
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.! !

!PRDocumentItemTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRDocumentItem! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass new! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 12/20/2007 20:10'!
assertTree: aDocument equalsText: aString
	self
		assert: (PRTextWriter write: aDocument) = aString
		description: aString resumable: true! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 12/20/2007 15:03'!
assertTree: aDocument equalsWiki: aString
	"Asswert that traversing aDocument using the wiki writer results in aString."

	self
		assert: (PRWikiWriter write: aDocument) = aString
		description: aString resumable: true! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 8/27/2007 10:39'!
assertWiki: aString equalsTree: aDocument
	"Assert that parsing aString results in aDocument."

	self
		assert: (PRDocumentParser parse: aString) = aDocument
		description: aString resumable: true! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 4/5/2007 14:32'!
barInstance
	^ PRText content: 'bar'! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 4/5/2007 14:32'!
fooInstance
	^ PRText content: 'foo'! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
foobarInstances
	^ Array with: self fooInstance with: self barInstance! !

!PRDocumentItemTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ instance! !

!PRDocumentItemTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	super setUp.
	instance := self actualInstance! !

!PRDocumentItemTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopy
	self assert: self instance = self instance copy.
	self assert: self instance hash = self instance copy hash.

	self deny: self instance == self instance copy! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqueal
	self assert: self instance = self instance.
	self assert: self instance = self actualInstance! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEquealNil
	self deny: self instance isNil! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEquealOther
	self deny: self instance = self fooInstance.
	self deny: self instance = self barInstance! !

!PRDocumentItemTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasChildren
	self deny: self instance hasChildren! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testHash
	self assert: self instance hash = self instance copy hash! !

!PRDocumentItemTest methodsFor: 'testing' stamp: 'lr 3/30/2009 21:36'!
testIsLink
	self deny: self instance isLink! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testOwner
	self assert: self instance owner isNil! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self assert: self instance text isString! !

PRDocumentItemTest subclass: #PRHorizontalRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRHorizontalRuleTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRHorizontalRuleTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRHorizontalRule! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 2/7/2007 16:42'!
testParseBasic
	| wiki text tree |
	wiki := '_'.
	text := self textString.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 15:59'!
testParseLink
	| wiki1 wiki2 text tree |
	wiki1 := '_ *link*'.
	wiki2 := '\_ *link*'.
	text := '_ link'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '_ ');
			add: (PRInternalLink new
				reference: 'link';
				yourself);
			yourself);
		yourself.
	self assertWiki: wiki1 equalsTree: tree.
	self assertWiki: wiki2 equalsTree: tree.
	self assertTree: tree equalsWiki: wiki2.
	self assertTree: tree equalsText: text! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseMultiple
	| wiki text tree |
	wiki := '_' , (String with: Character cr) , '_' , (String with: Character cr) , (String with: Character cr) , '_'.
	text := self textString , (String with: Character cr) , self textString , (String with: Character cr) , (String with: Character cr) , self textString.
	tree := PRDocument new
		add: PRHorizontalRule new;
		add: PRHorizontalRule new;
		add: PREmptyParagraph new;
		add: PRHorizontalRule new;
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:33'!
testParseParagraph
	| wiki text tree |
	wiki := '\_ is parsed as paragraph'.
	text := '_ is parsed as paragraph'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '_ is parsed as paragraph');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'nfr 9/26/2007 09:55'!
testParseSpaces
	| wiki text tree |
	wiki := '_       '.
	text := self textString.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: '_'.
	self assertTree: tree equalsText: text! !

!PRHorizontalRuleTest methodsFor: 'private' stamp: 'lr 2/7/2007 16:42'!
textString
	^ String new: 40 withAll: $-! !

PRDocumentItemTest subclass: #PRLineBreakTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRLineBreakTest class methodsFor: 'testing' stamp: 'lr 12/9/2007 09:24'!
isAbstract
	^ false! !

!PRLineBreakTest methodsFor: 'private' stamp: 'lr 12/9/2007 09:24'!
actualClass
	^ PRLineBreak! !

!PRLineBreakTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseOneEmptyLine
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , (String with: Character cr) , 'Nulla quis urna.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				yourself);
		add: PREmptyParagraph new;
		add: (PRParagraph new add: (PRText content: 'Nulla quis urna.') yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRLineBreakTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTreeLines
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , 'Nulla quis urna.' , (String with: Character cr) , 'Vestibulum turpis.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				add: PRLineBreak new;
				add: (PRText content: 'Nulla quis urna.');
				add: PRLineBreak new;
				add: (PRText content: 'Vestibulum turpis.');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

!PRLineBreakTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTwoEmptyLines
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , (String with: Character cr) , (String with: Character cr) , 'Nulla quis urna.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				yourself);
		add: PREmptyParagraph new;
		add: PREmptyParagraph new;
		add: (PRParagraph new add: (PRText content: 'Nulla quis urna.') yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: text.
	self 
		assertTree: tree
		equalsText: text! !

!PRLineBreakTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testParseTwoLines
	| wiki text tree |
	wiki := 'Lorem ipsum dolor sit amet.' , (String with: Character cr) , 'Nulla quis urna.'.
	text := wiki.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: 'Lorem ipsum dolor sit amet.');
				add: PRLineBreak new;
				add: (PRText content: 'Nulla quis urna.') yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki.
	self 
		assertTree: tree
		equalsText: text! !

PRDocumentItemTest subclass: #PRTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRTextTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRTextTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRText! !

!PRTextTest methodsFor: 'testing-instantiation' stamp: 'lr 4/5/2007 14:41'!
testContent
	instance := self actualClass content: 'zork'.
	self assert: self instance text = 'zork'! !

!PRTextTest methodsFor: 'testing-comparing' stamp: 'lr 4/5/2007 14:43'!
testEqualText
	self deny: (self actualClass content: 'foo') = (self actualClass content: 'bar')! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 9/4/2009 17:04'!
testEscapeCpp
	| wiki tree |
	wiki := 'Text: \+\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: 'Text: ++');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testEscapeFirst
	| wiki tree |
	wiki := '\* text' , (String with: Character cr) , '\+ text' , (String with: Character cr) , '\= text' , (String with: Character cr) , '\@ text' , (String with: Character cr) , '\!! text' , (String with: Character cr) , '\| text' , (String with: Character cr) , '\# text' , (String with: Character cr) , '\- text'.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: '* text');
				add: PRLineBreak new;
				add: (PRText content: '+ text');
				add: PRLineBreak new;
				add: (PRText content: '= text');
				add: PRLineBreak new;
				add: (PRText content: '@ text');
				add: PRLineBreak new;
				add: (PRText content: '!! text');
				add: PRLineBreak new;
				add: (PRText content: '| text');
				add: PRLineBreak new;
				add: (PRText content: '# text');
				add: PRLineBreak new;
				add: (PRText content: '- text');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'jf 11/2/2009 10:39'!
testEscapeStrange
	| wiki tree |
	wiki := '< text' , (String with: Character cr) , '> text'.
	tree := PRDocument new
		add: (PRParagraph new
				add: (PRText content: '< text');
				add: PRLineBreak new;
				add: (PRText content: '> text');
				yourself);
		yourself.
	self 
		assertWiki: wiki
		equalsTree: tree.
	self 
		assertTree: tree
		equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:37'!
testEscapeText
	| wiki tree |
	wiki := 'Text: \*\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: 'Text: *+');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:39'!
testEscapeWiki
	| wiki tree |
	wiki := 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:39'!
testParseBasic
	| wiki tree |
	wiki := 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:40'!
testParseHtml
	| wiki tree |
	wiki := '<strong>strong <emph>strong, emph</emph></strong>'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '<strong>strong <emph>strong, emph</emph></strong>');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:40'!
testParseLatex
	| wiki text tree |
	wiki := '\\begin{foo}[bar]$zork$\\end{foo}'.
	text := '\begin{foo}[bar]$zork$\end{foo}'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText content: '\begin{foo}[bar]$zork$\end{foo}');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:40'!
testParseSpecial
	| wiki tree |
	wiki := '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: (PRText
										content: '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???');
							yourself);
				yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 4/5/2007 14:40'!
testParseWiki
	| wiki tree |
	wiki := ' !!_#-|=]@:<>\*'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: (PRText content: ' !!_#-|=]@:<>*');
							yourself);
				yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki! !

!PRTextTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self instance text: 'zork'.
	self assert: self instance text = 'zork'! !

PRDocumentItemTest subclass: #PRVerbatimTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Document'!

!PRVerbatimTest class methodsFor: 'testing' stamp: 'lr 2/2/2010 15:40'!
isAbstract
	^ false! !

!PRVerbatimTest methodsFor: 'private' stamp: 'lr 2/2/2010 15:40'!
actualClass
	^ PRVerbatim! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 15:41'!
testParseBasic
	| wiki text tree |
	wiki := '{{{abc}}}'.
	text := 'abc'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: 'abc');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 15:52'!
testParseEmpty
	| wiki text tree |
	wiki := '{{{}}}'.
	text := ''.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: '');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 16:25'!
testParseMultiline
	| wiki text tree |
	wiki := '{{{a' , (String with: Character cr) , 'b}}}'.
	text := 'a' , (String with: Character cr) , 'b'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: 'a' , (String with: Character cr) , 'b');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 17:23'!
testParseMultiple
	| wiki text tree |
	wiki := '{{{a}}}b{{{c}}}'.
	text := 'abc'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: 'a');
			add: (PRText content: 'b');
			add: (PRVerbatim content: 'c');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 17:37'!
testParseMultipleMultiline
	| wiki text tree |
	wiki := '{{{a' , (String with: Character cr), 'b}}}c{{{d', (String with: Character cr), 'e}}}'.
	text := 'a' , (String with: Character cr), 'bcd', (String with: Character cr) , 'e'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: 'a' , (String with: Character cr) , 'b');
			add: (PRText content: 'c');
			add: (PRVerbatim content: 'd' , (String with: Character cr) , 'e');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-parsing' stamp: 'lr 2/2/2010 15:53'!
testParseStrange
	| wiki text tree |
	wiki := '{{{a{{}}b}}}'.
	text := 'a{{}}b'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRVerbatim content: 'a{{}}b');
			yourself);
		yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text! !

!PRVerbatimTest methodsFor: 'testing-accessing' stamp: 'lr 2/2/2010 16:01'!
testText
	self instance text: 'zork'.
	self assert: self instance text = 'zork'! !

PRObjectTest subclass: #PRKernelTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Kernel'!

!PRKernelTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRKernelTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRKernel! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self kernel! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!PRKernelTest methodsFor: 'testing' stamp: 'lr 1/17/2007 10:44'!
testInitialState
	self deny: self kernel name isNil.
	self deny: self kernel root isNil.
	self deny: self kernel persistency isNil! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self kernel name: 'kernel'.
	self assert: self kernel name = 'kernel'! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 2/18/2009 14:43'!
testPersistency
	| persistency1 persistency2 |
	self kernel persistency: (persistency1 := PRHistoryPersistency new).
	self assert: self kernel persistency = persistency1.
	self assert: self kernel = persistency1 kernel.

	self kernel persistency: (persistency2 := PRNullPersistency new).
	self assert: persistency1 kernel isNil.
	self assert: self kernel persistency = persistency2.
	self assert: self kernel = persistency2 kernel.
		
	self kernel persistency: nil.
	self assert: persistency2 kernel isNil.
	self assert: self kernel persistency kernel = self kernel! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	| structure |
	self kernel root: (structure := PRPage new).
	self assert: self kernel root = structure! !

!PRObjectTest class methodsFor: 'building' stamp: 'jf 9/30/2009 01:10'!
buildTestClassFor: aClass 
	" self buildTestClassFor: PRObject "
	| thisName thisClass thisCategory parentClass |
	thisName := (aClass name , 'Test') asSymbol.
	(thisName beginsWith: 'PR') ifFalse: [ ^ self ].
	thisClass := GRPlatform current magritteClassNamed: thisName.
	thisCategory := 'Pier-Tests-' , (aClass category copyAfterLast: $-).
	parentClass := self = thisClass 
		ifTrue: [ self superclass ]
		ifFalse: 
			[ GRPlatform current magritteClassNamed: (aClass superclass name , 'Test') asSymbol ].
	thisClass := parentClass 
		subclass: thisName
		instanceVariableNames: (thisClass isNil 
				ifFalse: [ thisClass instanceVariablesString ]
				ifTrue: [ String new ])
		classVariableNames: ''
		poolDictionaries: ''
		category: thisCategory.
	thisClass 
		compile: 'actualClass
	^ ' , aClass name
		classified: #private.
	thisClass class 
		compile: 'isAbstract
	^ ' , aClass isAbstract greaseString
		classified: #testing.
	aClass subclassesDo: [ :each | self buildTestClassFor: each ]! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRObjectTest class methodsFor: 'accessing' stamp: 'lr 4/12/2009 00:26'!
packageNamesUnderTest
	^ #('Pier-Model')! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
shouldInheritSelectors
	^ true! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRObject! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
contextInstance
	^ PRContext kernel: self kernelInstance! !

!PRObjectTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	self subclassResponsibility! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
kernelInstance
	^ PRKernel new
		name: 'test';
		root: self rootInstance;
		persistency: self persistencyInstance;
		yourself! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
persistencyInstance
	^ PRNullPersistency new! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 1/15/2007 21:34'!
rootInstance
	^ (PRPage named: 'root')
		addChild: ((PRPage named: 'folder')
			addChild: (PRPage named: 'child');
			addChild: (self structureInstance);
			yourself);
		yourself! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 1/15/2007 21:34'!
structureInstance
	^ PRPage named: 'structure'! !

!PRObjectTest methodsFor: 'testing-copying' stamp: 'lr 6/22/2008 18:24'!
testCopyProperties
	self deny: self instance properties == self instance copy properties! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testProperties
	self assert: self instance properties notNil.
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo put: #bar.
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsent: [ nil ].
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsentPut: [ #bar ].
	self instance instVarNamed: 'properties' put: nil.

	self instance hasProperty: #foo.
	self instance instVarNamed: 'properties' put: nil! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/5/2007 14:07'!
testPropertiesAt
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.
	self should: [ self instance propertyAt: #bar ] raise: MAPropertyError! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtIfAbsent
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtIfAbsentPut
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsentPut: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.

	self assert: (self instance propertyAt: #bar ifAbsentPut: [ 'baz' ]) = 'baz'.
	self assert: (self instance propertyAt: #bar) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtPut
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.

	self instance propertyAt: #foo put: 'baz'.
	self assert: (self instance propertyAt: #foo) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesHas
	self deny: (self instance hasProperty: #foo).
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance hasProperty: #foo).
	self deny: (self instance hasProperty: #bar)! !

!PRObjectTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testSanity
	"If this test case fails, there is something wrong with the setup of the test-case."

	self
		assert: self actualClass isAbstract not
		description: 'Unable to test abstract class.'.
	self
		assert: self instance class = self actualClass
		description: 'Invalid test instance.'! !

PRObjectTest subclass: #PRPersistencyTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Persistence'!

!PRPersistencyTest commentStamp: 'kph 10/4/2006 19:56' prior: 0!
For persistency tests we do not bypass PRKernel instances, 
instead we use kernels prefixed with '####'.!

PRPersistencyTest subclass: #PRHistoryPersistencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Persistence'!

!PRHistoryPersistencyTest class methodsFor: 'testing' stamp: 'lr 9/23/2008 08:20'!
isAbstract
	^ false! !

!PRHistoryPersistencyTest methodsFor: 'private' stamp: 'lr 1/29/2008 08:17'!
actualClass
	^ PRHistoryPersistency! !

!PRHistoryPersistencyTest methodsFor: 'testing' stamp: 'lr 5/2/2009 11:31'!
testHistory
	| command |
	command := self editTitle: 'Foo'.
	self assert: self persistency history isEmpty.
	self 
		shouldnt: [ self persistency execute: command ]
		raise: Error.
	self assert: self persistency history size = 1.
	self deny: self persistency history first = command context.
	self assert: self persistency history first structure = command context structure! !

!PRHistoryPersistencyTest methodsFor: 'testing' stamp: 'lr 5/2/2009 11:33'!
testMaxHistory
	| command |
	self persistency maxHistory: 5.
	10 timesRepeat: [ 
		self persistency 
			execute: (command := self editTitle: 'Foo').
		self assert: self persistency history size <= 5 ].
	self assert: self persistency history size = 5! !

!PRHistoryPersistencyTest methodsFor: 'testing' stamp: 'lr 5/2/2009 11:33'!
testReplacement
	| command1 command2 |
	self persistency
		execute: (command1 := self editTitle: '1');
		execute: (command2 := self editTitle: '2').
	self assert: self persistency history size = 2.
	self deny: self persistency history first command = command1.
	self assert: self persistency history first command class = command1 class.
	self deny: self persistency history second command = command2.
	self assert: self persistency history second command class = command2 class.
	
	self kernel persistency: self persistencyInstance.
	self assert: self persistency history size = 2.
	self deny: self persistency history first command = command1.
	self assert: self persistency history first command class = command1 class.
	self deny: self persistency history second command = command2.
	self assert: self persistency history second command class = command2 class.
	
	self kernel persistency: nil.
	self assert: self persistency history isEmpty.
	
	self kernel persistency: self persistencyInstance.
	self assert: self persistency history isEmpty! !

PRPersistencyTest subclass: #PRNullPersistencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Persistence'!

!PRNullPersistencyTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRNullPersistencyTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRNullPersistency! !

!PRPersistencyTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ true! !

!PRPersistencyTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRPersistency! !

!PRPersistencyTest methodsFor: 'running' stamp: 'lr 9/23/2008 08:31'!
editTitle: aString
	| context |
	context := PRContext 
		kernel: self kernel 
		structure: self kernel root
		command: (PREditCommand new
			write: aString
			using: PRStructure descriptionTitle).
	^ context command! !

!PRPersistencyTest methodsFor: 'accessing' stamp: 'lr 1/17/2007 10:45'!
instance
	^ self persistency! !

!PRPersistencyTest methodsFor: 'accessing' stamp: 'lr 1/17/2007 10:55'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!PRPersistencyTest methodsFor: 'accessing' stamp: 'lr 1/17/2007 10:51'!
mutex
	^ self persistency mutex! !

!PRPersistencyTest methodsFor: 'accessing' stamp: 'lr 1/17/2007 10:51'!
persistency
	^ self kernel persistency! !

!PRPersistencyTest methodsFor: 'private' stamp: 'lr 1/17/2007 10:55'!
persistencyInstance
	^ self actualClass new! !

!PRPersistencyTest methodsFor: 'running' stamp: 'lr 1/17/2007 10:51'!
tearDown
	self kernel persistency: PRNullPersistency new! !

!PRPersistencyTest methodsFor: 'testing-smoke' stamp: 'lr 9/23/2008 08:24'!
testConveniance
	self assert: (self persistency history) isCollection.
	self assert: (self persistency historyFor: self kernel root) isCollection! !

!PRPersistencyTest methodsFor: 'testing-smoke' stamp: 'lr 9/23/2008 08:25'!
testEnumeration
	self persistency do: [ :each | ].
	self persistency do: [ :each | ] for: self kernel root.
	
	self persistency reverseDo: [ :each | ].
	self persistency reverseDo: [ :each | ] for: self kernel root! !

!PRPersistencyTest methodsFor: 'testing-mutex' stamp: 'lr 3/5/2007 14:04'!
testMutexError
	"An error inside the critical section should properly unlock it for others to enter."

	| marker |
	marker := nil.
	self
		should: [ self mutex critical: [ 1 / 0 ] ]
		raise: ZeroDivide.

	self mutex critical: [ marker := 1 ].
	self assert: marker = 1! !

!PRPersistencyTest methodsFor: 'testing-mutex' stamp: 'lr 1/17/2007 10:52'!
testMutexSimple
	| marker |
	marker := nil.
	self mutex critical: [ marker := 1 ].
	self assert: marker = 1! !

!PRPersistencyTest methodsFor: 'testing' stamp: 'lr 1/17/2007 11:22'!
testSetup
	self assert: self persistency kernel = self kernel.
	self assert: self kernel persistency = self persistency! !

TestCase subclass: #PRUtilitiesTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Utilities'!

!PRUtilitiesTests methodsFor: 'accessing' stamp: 'lr 4/24/2008 08:42'!
number1
	^ '1!!'! !

!PRUtilitiesTests methodsFor: 'accessing' stamp: 'lr 4/24/2008 08:42'!
number2
	^ '!!2'! !

!PRUtilitiesTests methodsFor: 'accessing' stamp: 'lr 4/24/2008 08:46'!
number3
	^ '3'! !

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 10/30/2006 19:49'!
testEnsureEscape
	| visitor tag |
	visitor := PRVisitor new.
	tag := nil.

	self assert: (visitor withEscaper: [
		[ true ]
			ensure: [ tag := 1 ] ]).
	self assert: tag = 1.

	self assert: (visitor withEscaper: [
		[ visitor escape: true ]
			ensure: [ tag := 2 ] ]).
	self assert: tag = 2! !

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 2/12/2007 19:07'!
testEscaper
	| visitor |
	visitor := PRVisitor new.

	self assert: (visitor withEscaper: [ true ]).
	self deny: (visitor withEscaper: [ false ]).

	self assert: (visitor withEscaper: [ visitor escape: true. false ]).
	self deny: (visitor withEscaper: [ visitor escape: false. true ])! !

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 10/30/2006 19:49'!
testHasEscaper
	| visitor |
	visitor := PRVisitor new.
	self deny: visitor hasEscaper.
	self assert: (visitor withEscaper: [ visitor hasEscaper ])! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 4/24/2008 08:47'!
testMacroExpand
	| expander |
	expander := PRMacroExpander new.
	expander
		on: $0 do: #(selector);
		on: $1 do: #(number1);
		on: $2 do: #(number2);
		on: $3 do: #(yourself number3).

	self assert: (expander expand: '' with: self) = ''.
	self assert: (expander expand: 'xyz' with: self) = 'xyz'.

	self assert: (expander expand: '%0' with: self) = 'testMacroExpand'.
	self assert: (expander expand: '%1' with: self) = '1!!'.
	self assert: (expander expand: '%2' with: self) = '!!2'.
	self assert: (expander expand: '%3' with: self) = '3'.

	self assert: (expander expand: '%1xy' with: self) = '1!!xy'.
	self assert: (expander expand: 'x%1y' with: self) = 'x1!!y'.
	self assert: (expander expand: 'xy%1' with: self) = 'xy1!!'.

	self assert: (expander expand: '%2xy' with: self) = '!!2xy'.
	self assert: (expander expand: 'x%2y' with: self) = 'x!!2y'.
	self assert: (expander expand: 'xy%2' with: self) = 'xy!!2'.

	self assert: (expander expand: '%1%2' with: self) = '1!!!!2'.
	self assert: (expander expand: 'x%1%2' with: self) = 'x1!!!!2'.
	self assert: (expander expand: 'x%1y%2' with: self) = 'x1!!y!!2'.
	self assert: (expander expand: 'x%1y%2z' with: self) = 'x1!!y!!2z'.

	self assert: (expander expand: '%%' with: self) = '%'.
	self assert: (expander expand: '%3' with: self) = '3'! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 4/24/2008 08:34'!
testMacroInitialized
	| expander |
	expander := PRMacroExpander new.

	self assert: expander character = $%.
	self assert: expander table isEmpty! !

TestCase subclass: #PRVisitorTests
	instanceVariableNames: 'root folder child1 child2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Utilities'!

!PRVisitorTests methodsFor: 'running' stamp: 'lr 2/12/2007 19:07'!
setUp
	root := PRPage named: 'root'.
	folder := PRPage named: 'folder'.
	child1 := PRPage named: 'child1'.
	child2 := PRPage named: 'child2'.

	root addChild: folder.
	folder addChild: child1.
	folder addChild: child2! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'NickAger 2/21/2010 10:07'!
testEnumerableDetect
	self assert: (root enumerator all detect: [ :each | each name = 'child2']) = child2.
	self should: [root enumerator detect: [ : each | each name = 'child2']] raise: GRObject defaultErrorClass.
	self shouldnt: [root enumerator detect: [ : each | each name = 'child2'] ifNone: [nil]] raise: GRObject defaultErrorClass! !

!PRVisitorTests methodsFor: 'testing-incoming' stamp: 'lr 1/19/2007 13:59'!
testIncomingReferencesMultiple
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.

	matched := root incomingReferences
		toAll: (Array with: root with: folder);
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'root' 'child1' ).
	matched := folder incomingReferences
		toAll: (Array with: root with: folder);
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'child1' ).
	matched := folder incomingReferences
		toAll: (Array with: child1 with: child2);
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' 'folder' )! !

!PRVisitorTests methodsFor: 'testing-incoming' stamp: 'lr 2/12/2007 19:07'!
testIncomingReferencesSingle
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.

	matched := root incomingReferences
		to: root;
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'child1' ).
	matched := root incomingReferences
		to: folder;
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'root' ).
	matched := root incomingReferences
		to: child1;
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' ).
	matched := root incomingReferences
		to: child2;
		collect: [ :each | each owner ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 2/12/2007 19:07'!
testOutgoingReferencesContinue
	| matched |
	root contents: '+folder+'.
	folder contents: '+child1+ +child2+'.
	child1 contents: '+/+'.
	child2 contents: ''.

	matched := root outgoingReferences
		continue: [ :each | false ];
		collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' ).
	matched := root outgoingReferences
		continue: [ :each | each owner = root ];
		collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' 'child1' 'child2' ).
	matched := root outgoingReferences
		continue: [ :each | each target ~= child1 ];
		collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' 'child1' 'child2' )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 2/12/2007 19:07'!
testOutgoingReferencesEmbedded
	| matched |
	root contents: '+folder+'.
	folder contents: '+child1+ +child2+'.
	child1 contents: '+/+'.
	child2 contents: ''.

	matched := root outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' 'child1' 'root' 'child2' ).
	matched := folder outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'child1' 'root' 'folder' 'child2' ).
	matched := child1 outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'root' 'folder' 'child1' 'child2' ).
	matched := child2 outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 2/12/2007 19:07'!
testOutgoingReferencesStandard
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.

	matched := root outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'folder' ).
	matched := folder outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'child1' 'child2' ).
	matched := child1 outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( 'root' ).
	matched := child2 outgoingReferences collect: [ :each | each target ].
	self assert: (matched collect: [ :each | each name ]) = #( )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 2/12/2007 19:07'!
testSearchCaseSensitive
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.

	match := root fullTextSearch subString: 'Bar'; caseSensitive: true.
	self assert: (match collect: [ :each | each name ]) = #( ).
	match := root fullTextSearch subString: 'bar'; caseSensitive: true.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).

	match := root fullTextSearch subString: 'Bar'; caseSensitive: false.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).
	match := root fullTextSearch subString: 'bar'; caseSensitive: false.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).

	match := root fullTextSearch subString: 'Bar'.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).
	match := root fullTextSearch subString: 'bar'.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 2/12/2007 19:07'!
testSearchContents
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.

	match := root fullTextSearch subString: 'foo'.
	self assert: (match collect: [ :each | each name ]) = #( 'root' ).
	match := root fullTextSearch subString: 'bar'.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).
	match := root fullTextSearch subString: 'zork'.
	self assert: (match collect: [ :each | each name ]) = #( 'child1' ).
	match := root fullTextSearch subString: 'plonk'.
	self assert: (match collect: [ :each | each name ]) = #( 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 2/12/2007 19:07'!
testSearchMultiple
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.

	match := root fullTextSearch subString: '1'.
	self assert: (match collect: [ :each | each name ]) = #( 'root' 'child1' ).
	match := root fullTextSearch subString: '2'.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 2/12/2007 19:07'!
testSearchNonRoot
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.

	match := root fullTextSearch subString: 'plonk'.
	self assert: (match collect: [ :each | each name ]) = #( 'child2'  ).
	match := folder fullTextSearch subString: 'plonk'.
	self assert: (match collect: [ :each | each name ]) = #( 'child2'  ).
	match := child1 fullTextSearch subString: 'plonk'.
	self assert: (match collect: [ :each | each name ]) = #(  ).
	match := child2 fullTextSearch subString: 'plonk'.
	self assert: (match collect: [ :each | each name ]) = #( 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 2/12/2007 19:07'!
testSearchTitle
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.

	match := root fullTextSearch subString: 'root'.
	self assert: (match collect: [ :each | each name ]) = #( 'root' ).
	match := root fullTextSearch subString: 'folder'.
	self assert: (match collect: [ :each | each name ]) = #( 'folder' ).
	match := root fullTextSearch subString: 'child1'.
	self assert: (match collect: [ :each | each name ]) = #( 'child1' ).
	match := root fullTextSearch subString: 'child2'.
	self assert: (match collect: [ :each | each name ]) = #( 'child2' )! !

MAElementDescriptionTest subclass: #PRStructureDescriptionTest
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Magritte'!

!PRStructureDescriptionTest class methodsFor: 'testing' stamp: 'lr 11/2/2007 13:55'!
isAbstract
	^ false! !

!PRStructureDescriptionTest methodsFor: 'private' stamp: 'lr 11/2/2007 13:56'!
actualClass
	^ PRStructureDescription! !

!PRStructureDescriptionTest methodsFor: 'private' stamp: 'lr 11/2/2007 14:05'!
context
	^ PRContext kernel: PRKernel new structure: self includedInstance! !

!PRStructureDescriptionTest methodsFor: 'private' stamp: 'lr 11/2/2007 14:03'!
includedInstance
	^ page ifNil: [ page := PRPage new ]! !

!PRStructureDescriptionTest methodsFor: 'running' stamp: 'lr 11/2/2007 14:00'!
runCase
	PRCurrentContext use: self during: [ super runCase ]! !

MAMemoDescriptionTest subclass: #PRDocumentDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Magritte'!

!PRDocumentDescriptionTest methodsFor: 'private' stamp: 'lr 11/2/2007 13:56'!
actualClass
	^ PRDocumentDescription! !

!PRDocumentDescriptionTest methodsFor: 'private' stamp: 'lr 11/2/2007 13:57'!
includedInstance
	^ self description fromString: '!!Hello World'! !

!PRDocumentDescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/19/2008 21:13'!
testAccessor
	"This doesn't work, as the document description wraps the accessor with an accessor-delegator."! !

!GRPackage class methodsFor: '*pier-tests-model' stamp: 'lr 2/18/2010 10:36'!
pierTestsModel
	^ self new
		name: 'Pier-Tests-Model';
		description: 'Tests for the Pier contennt management system.';
		addDependency: 'Pier-Model';
		addDependency: 'Magritte-Tests-Model';
		url: #pierUrl;
		yourself! !

PRDecoration subclass: #PRMockDecoration
	instanceVariableNames: 'priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Model-Mocks'!

!PRMockDecoration class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= aDecoration
	^ super = aDecoration
		and: [ self priority = aDecoration priority ]! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self priority hash! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ priority! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority: anInteger
	priority := anInteger! !
